/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <windows.h>
#include <stdio.h>
#include "resource.h"

#include "msg.h"
#include "types.h"
#include "hashdef.h"
#include "main.h"
#include "limits.h"

/* Should just go in a dialog-box specific file */

int ABOUT_compare( const void *arg1, const void *arg2 )
{
   /* Compare all of both strings: */
   return _stricmp( * ( char** ) arg1, * ( char** ) arg2 );
}

int WINAPI ABOUT_DialogBox(HINSTANCE hinstance, HWND hwnd)
{
	char buf[2048];
	int i, j, unique;
	char* names[MAX_SERVER_TYPES];

	strcpy(buf, 
		"This program is provided under the GPL.\n\n"
		"Author: Nathan O'Sullivan\n"
		"Web: http://www.serverquery.com/\n"
		"Email: nathan@ausgamers.com\n--------------------------------\nLoaded DLLs:  "
	);

	for (i=0,j=0;i<MAX_SERVER_TYPES;i++)
		if (!GetServerType(i)->invalid)
			names[j++] = GetServerType(i)->name;

	qsort(names,j,sizeof (char*),ABOUT_compare);
	
	for (i=0;i<j;i++)
			sprintf(buf+strlen(buf),"%s, ",names[i]);
	
	buf[strlen(buf)-2] = 0; 

	

	unique = 0;
	for (i=0;i<G_NumHashes;i++)
	{
		for (j=0;j<i;j++)
			if (G_Hashes[j]->owner == G_Hashes[i]->owner)
				break;
		if (j == i)
			unique++;
	}

	//sprintf(buf,"%d hashes, %d unique",G_NumHashes,unique);


	MSG_DialogBox(NULL,PROG_HWND, buf, IDD_WELCOME);
	return 0;
}
