/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <stdio.h>

#include "resource.h"
#include "types.h"
#include "main.h"
#include "limits.h"

int BUDDY_Close(HWND hwnd) 
{
	int i, limit;
	char buf[128];

	limit = SendMessage(GetDlgItem(hwnd,IDC_LIST),LB_GETCOUNT,0,0);
	HashDeleteAll(HASH_GLOBAL,"Buddy");

	for (i=0;i<limit;i++)
	{
		SendMessage(GetDlgItem(hwnd,IDC_LIST),LB_GETTEXT,i,(LPARAM)buf);
		buf[127] = 0;
		HashInsertText(HASH_GLOBAL,"Buddy",HASH_ANY,buf);
	}
	DestroyWindow(hwnd);
	
	return 0;
}			

HANDLE hinst;

char* current_path, *current_param;
	


int WINAPI BUDDY_DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int i, which;
	char buf[128];

	switch (msg) {
		case WM_COMMAND:
			if (LOWORD(wParam) == IDB_REMOVEALL)
			{
				SendMessage(GetDlgItem(hwnd,IDC_LIST),LB_RESETCONTENT,0,0);
			}
			if (LOWORD(wParam) == IDB_REMOVE)
			{
				i = SendMessage(GetDlgItem(hwnd,IDC_LIST),LB_GETCURSEL,0,0);
				if (i != LB_ERR)
				{
					SendMessage(GetDlgItem(hwnd,IDC_LIST),LB_DELETESTRING,i,0);
					SendMessage(GetDlgItem(hwnd,IDC_LIST),LB_SETCURSEL,i,0);
				}
			}
			if (LOWORD(wParam) == IDB_ADD)
			{
				GetDlgItemText(hwnd,IDT_NAME,buf,128);
				buf[127] = 0;
				SendMessage(GetDlgItem(hwnd,IDC_LIST),LB_ADDSTRING,0,(LPARAM)buf);
				SetFocus(GetDlgItem(hwnd,IDT_NAME));

			}
			else if (LOWORD(wParam) == IDC_GAME && HIWORD(wParam) == LBN_SELCHANGE)
			{
				which = SendMessage(GetDlgItem(hwnd, IDC_GAME), CB_GETCURSEL, 0, 0);
				SendMessage(GetDlgItem(hwnd,IDC_GAME),CB_GETLBTEXT,which,(LPARAM)buf);
				for (i=0;i<MAX_SERVER_TYPES;i++) {
					if (strcmp(GetServerType(i)->name,buf) == 0) 
						break;
				}
				if (i!=MAX_SERVER_TYPES) {
					SendMessage(GetDlgItem(hwnd, IDT_PATH), WM_SETTEXT, 0, (LPARAM)(current_path = GetServerType(i)->path));
					SendMessage(GetDlgItem(hwnd, IDT_PARAMETERS), WM_SETTEXT, 0, (LPARAM)(current_param = GetServerType(i)->parameters));
				}
			}
			else if (LOWORD(wParam) == IDT_PATH && HIWORD(wParam) == EN_KILLFOCUS)
				SendMessage(GetDlgItem(hwnd, IDT_PATH), WM_GETTEXT, 128, (LPARAM)current_path);

			else if (LOWORD(wParam) == IDT_PARAMETERS && HIWORD(wParam) == EN_KILLFOCUS)
				SendMessage(GetDlgItem(hwnd,IDT_PARAMETERS),WM_GETTEXT,128,(LPARAM)current_param);
			else if (LOWORD(wParam) == IDOK)
				return BUDDY_Close(hwnd);
			return 0;
		case WM_CLOSE:
			BUDDY_Close(hwnd);
			return 0;
	}
	return 0;
}


void BUDDY_DialogBox(void)
{
	HWND hwnd;
	//char* str;
	int i;
	hwnd = CreateDialog(PROG_HINSTANCE, MAKEINTRESOURCE(IDD_BUDDY), PROG_HWND, BUDDY_DlgProc);
	
	
	for (i=0;i<HashCount(HASH_GLOBAL,"Buddy");i++)
		SendMessage(GetDlgItem(hwnd, IDC_LIST), LB_ADDSTRING, 0, (LPARAM)HashSelectText(HASH_GLOBAL,"Buddy",(HASH_PARAM)i));

	ShowWindow(hwnd,SW_SHOW);
	return;
}
