#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include "chat.h"

#define g_stricmp stricmp

/* NB: Different to server side, as this version returns the index into the
	stack (ie for deletion) - also does a strstr instead of stricmp */
int stack_search(CHAT_DATA* user, char* msg)
{
  int i;

  for (i=0;i<user->stack_size;i++)
    if (strstr(user->stack[i]->msg,msg) != NULL)
      return i;

  return -1;
}

int stack_addmessage(CHAT_DATA* user, char* msg, int svid, int clid)
{
  msgstack_t* item;

  item = calloc(1,sizeof(msgstack_t));
  strcpy(item->msg,msg);
  if (svid) {
    item->svid = svid;
	if (svid > user->svid)
		user->svid = svid;
  }
  if (clid > 0)
    item->clid = (++user->clid);

  if (clid == -1)
    item->clid = user->stack[user->stack_size - 1]->clid;

  user->stack[user->stack_size++] = item;
  return 0;
}

int stack_svid(CHAT_DATA* user, int item)
{
  int i;
  for (i=0;i<user->stack_size;i++)
    if (user->stack[i]->svid == item)
      return i;

  return -1;
}

/*int stack_setclid(CHAT_DATA* user, int svid, int clid)
{
  int i;

  if (svid == 0)
    return 0;

  if ((i = stack_svid(user,svid)) != -1)
    user->stack[i]->clid = clid;

  return 0;
}*/
int stack_clid(CHAT_DATA* user, int item)
{
  int i;
  if (item == 0)
	  return -1;

  for (i=0;i<user->stack_size;i++)
    if (user->stack[i]->clid == item)
      return i;

  return -1;
}
 
int stack_delmessage(CHAT_DATA* user, int item)
{
  int i;
  if (item < 0)
    return 0;

  free(user->stack[item]);
  for (i=item;i<user->stack_size-1;i++)
    user->stack[i] = user->stack[i+1];
  user->stack_size--;
  return 0;
}
 
/*int stack_delprevclids(user_t* user, int item)
{
  int i;
  if (item < 0)
    return 0;

  for (i=0;i<user->stack_size;)
    if (user->stack[i]->clid && user->stack[i]->clid < item)
      stack_delmessage(user,i);
    else i++;

  return 0;
}*/

int stack_empty(CHAT_DATA* user)
{
  int i;

  for (i=0;i<user->stack_size;i++)
    free(user->stack[i]);
  
  user->stack_size = 0;
  return 0;
}

/*int stack_dump(int userid)
{
  user_t* user = users+userid;
  int i;
  printf("Stack:\n");
  for (i=0;i<user->stack_size;i++)
  {
    printf("%d: %s (sv:%d,cl:%d)\n",i+1,user->stack[i]->msg,
        user->stack[i]->svid, user->stack[i]->clid);
  }
  return 0;
}*/
