/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include "resource.h"
#include <windows.h>
#include <stdio.h>
#include "servers.h"
#include "main.h"

int WINAPI CVARS_DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	if ((msg == WM_COMMAND && wParam == IDB_OK) || msg == WM_CLOSE)
		DestroyWindow(hwnd);
			
	return 0;
}


void CVARS_DialogBox(server_t* svr)
{
	HWND hwnd;
	int tabstops[10], i;
	char buf[512];
	HASH* hash;

	if (svr == NULL)
		return;
	hwnd = CreateDialog(PROG_HINSTANCE, MAKEINTRESOURCE(IDD_CVARS), PROG_HWND, CVARS_DlgProc);

	tabstops[0] = 70;
	
	SendMessage(GetDlgItem(hwnd, IDT_CVARS), LB_SETTABSTOPS, 1, (LPARAM)tabstops);

	hash = HashGet(svr, "items");
	for (i=0;i<hash->num;i++)
	{
		sprintf(buf, "%s\t%s", hash->entries[i]->key, hash->entries[i]->value);
		SendMessage(GetDlgItem(hwnd, IDT_CVARS), LB_ADDSTRING, 0, (LPARAM)buf);
	}
	
	return;
}
