/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <stdio.h>
#include "resource.h"

#include "types.h"
#include "msg.h"
#include "shared.h"
#include "comm.h"
#include "resolve.h"

int DEFAULT_isPacketFrom(server_t* svr, SOCKADDR* addr)
{
	SOCKADDR_IN* dest_addr = (SOCKADDR_IN*)addr;
	if (dest_addr->sin_addr.s_addr == GetServerAddr(svr->ipaddr)
		&& dest_addr->sin_port == htons(GetServerPort(svr->ipaddr, svr->gametype->port) ) )
		return 1;
	return 0;
}

void DEFAULT_send (SOCKET s, server_t* svr, short port)
{
	char buf[128];
	sprintf(buf, "Undefined server type %s while sending.", svr ? svr->gametype->qstat_type : "-");
	//MSG_DialogBox(NULL,NULL,buf,IDD_ERROR);
	return;
}
int DEFAULT_receive (server_t* svr, char* data, int len)
{
	char buf[128];
	sprintf(buf, "Undefined server type %s while receiving.",svr ? svr->gametype->qstat_type : "-");
	//MSG_DialogBox(NULL,NULL,buf,IDD_ERROR);
	return 0;
}

void DEFAULT_print_info (server_t* svr, HWND hwnd, int ignore)
{
	char buf[128];
	sprintf(buf, "Undefined server type %s while printing info.",svr ? svr->gametype->qstat_type : "-");
	SetWindowText(GetDlgItem(hwnd,IDT_HOSTNAME),"Missing DLL");
	//MSG_DialogBox(NULL,NULL,buf,IDD_ERROR);
	return;
}
char* DEFAULT_hostname (server_t* svr) 
{
//	char buf[128];
	//sprintf(buf, "Undefined server type %d while finding hostname.",svr ? svr->type : -1);
	//MSG_DialogBox(NULL,NULL,buf,IDD_ERROR);
	return "";
}

void SetDefault(types_t* svr)
{
	//svr->type = 0;
	svr->invalid = 1;
	svr->port = 0;
	strcpy(svr->name, "Default Server Type");
	strcpy(svr->path, "");
	svr->send = DEFAULT_send;
	svr->receive = DEFAULT_receive;
	svr->print_info = DEFAULT_print_info;
	svr->hostname = DEFAULT_hostname;
}
