/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <stdio.h>

#include "types.h"
#include "resource.h"
#include "msg.h"
#include "main.h"
#include "list.h"
#include "qstat.h"
#include "motd.h"

#define QUERY_VERSION "QUERY191"


//extern server_t* head;

char* strip(char* str)
{
	if (strlen(str))
		str[strlen(str) - 1] = 0;
	return str;
}

/* 
***
This doesn't belong here 
***
*/
list_t* FindListFullNamed(char* name, list_t* parent, list_t** store) {
	int i;
	char tmp[128];
	char tmp2[2048];
	for (i=0;i<(int) strlen(name);i++)
		if (name[i] == '\034')
		{
			name[i] = 0;
			strcpy(tmp,name);
			strcpy(tmp2,name+i+1);
			strcpy(name,tmp2);
			return FindListFullNamed(name,ListNamedWithParent(tmp,parent),store);
		}
	if (store)
		*store = parent;
	return ListNamedWithParent(name,parent);
}
	

int WINAPI DISK_DlgProc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
	return 0;
}

int LoadFileFromDisk(char* file, int needver, int settings, int programs, int servers)
{
	FILE* in;
	char name[256], ipaddr[128];
	char key[128], value[128];
	char qstat_type[32];

	list_t* newlist, *parent;
	int i, num_types, num;
	char list[128];
	HWND hwnd;

	// temp
	// server_t* tempsvr;

	in = fopen(file,"rt");

	if (!in) 
		return 0;

	hwnd = CreateDialog(PROG_HINSTANCE,MAKEINTRESOURCE(IDD_LOAD),PROG_HWND,DISK_DlgProc);
	ShowWindow(hwnd,SW_SHOW);
	
		if (needver)
		{
			fgets(name, 128, in);
			strip(name);
			if (strcmp(name, QUERY_VERSION))
			{
				DestroyWindow(hwnd);
				MSG_DialogBox(NULL,NULL,NULL,IDD_WELCOME);
				fclose(in);
				return 0;
			}
		}
		//else {
			if (settings) {
				while (!feof(in) && fgets(name, 128, in)>0)
				{
					strip(name);
					if (!strcmp(name,"[SETTINGS]"))
						break;
				}
			
				if (!feof(in))
				{
					fscanf(in, "%d\n", &num);
					for (i=0;i<num;i++)
					{
						fgets(key,128,in);
						strip(key);
						fgets(value,128,in);
						strip(value);

						if (strcmp(key,"buddy") == 0)
							HashInsert(HASH_GLOBAL,"Buddy",HASH_ANY,value,HASH_STRING);
						else
							HashInsert(HASH_GLOBAL,"Settings",key,value,HASH_STRING);
					}					
				}

				fclose(in);
				in = fopen(file,"rt");
			}
	
			if (programs) {
				while (!feof(in) && fgets(name, 128, in)>0)
				{
					strip(name);
					if (!strcmp(name,"[PATHS]"))
						break;
				}
			
				if (!feof(in)) {
					fscanf(in, "%d\n", &num_types);
					for (i=0;i<num_types;i++)
					{
						fgets(name,64,in);
						fgets(name+64,128,in);
						//sscanf(name, "%d\n", &type);
						strip(name);
						strip(name+64);
						if (!GetServerType_gamespy(name)->invalid)
							strcpy(GetServerType_gamespy(name)->path, name+64);
					}
				}

				fclose(in);
				in = fopen(file,"rt");
	
				while (!feof(in) && fgets(name, 128, in)>0)
				{
					strip(name);
					if (!strcmp(name,"[PARAMETERS]"))
						break;
				}
			
				if (!feof(in)) {
					fscanf(in, "%d\n", &num_types);
					for (i=0;i<num_types;i++)
					{
						fgets(name,64,in);
						fgets(name+64,128,in);
						//sscanf(name, "%d", &type);
						strip(name);
						strip(name+64);
						if (GetServerType_gamespy(name)->invalid == 0)
							strcpy(GetServerType_gamespy(name)->parameters, name+64);
					}
				}
			
			fclose(in);
			in = fopen(file,"rt");

		}
		if (servers) {
			while (!feof(in) && fgets(name, 128, in)>0)
			{
				strip(name);
				if (!strcmp(name,"[SERVERS]"))
					break;
			}
			if (!feof(in))
				// wipe the list
				// FIXME - HASH_GLOBAL->"Servers" doesn't exist
				HashFree(HASH_GLOBAL,"Servers");

			while (!feof(in) && fgets(name, 128, in)>0)
			{
				fgets(ipaddr, 128, in);
				fscanf(in, "%s\n", qstat_type);

				// fix broken q3 stuff
				//if (type == 14)
				//	type = 6;

				if (!GetServerType_qstat(qstat_type)->invalid)
					AddServer((list_t*)HashFind(HASH_GLOBAL,"Lists","NetServers",(int)GroupOfList(NULL)->desc), NewServer(strip(name),strip(ipaddr),qstat_type));
			}

			fclose(in);
			in = fopen(file,"rt");

			while (!feof(in) && fgets(name, 128, in)>0)
			{
				strip(name);
				if (strstr(name,"[SERVERLIST_") )
					break;
			}

			//tempsvr = NewServer("Q3A","202.139.226.2",6);

			// keep looping through server lists
			while (!feof(in)) {

				// get list name
				memcpy(list,name+strlen("[SERVERLIST_"),64);
				if (strstr(list,"]"))
					(strstr(list,"]"))[0] = 0;
				
				while (!feof(in) && fgets(name, 128, in)>0)
				{
					strip(name);
					if (!name[0])
						continue;
					if (memcmp(name,"[SERVERLIST_",12) == 0)
						break;
					/* old stuff for compatibility */
					if (memcmp(name,"TYPE=",5) == 0)
					{
						parent = NULL;

						newlist = FindListFullNamed(list,NULL,&parent);
						if (newlist)
							DeleteList(newlist);
					
						if (strcmp(name+5,"PupServers") == 0) {
							newlist = CreateList(list,"QStatList",parent);
							HashInsert(newlist,"Extra","URL","http://serverquery.qgl.org/powerup.txt",HASH_STRING);
						}
						else 
							newlist = CreateList(list,name+5,parent);
					}
					/* end old stuff */
					else if (memcmp(name,"\033\033\033\033",4) == 0) {
						if (memcmp(name+4,"TYPE=",5) == 0)
						{
							parent = NULL;

							newlist = FindListFullNamed(list,NULL,&parent);
							if (newlist)
								DeleteList(newlist);
							
							newlist = CreateList(list,name+9,parent);
						} else {
							i = 4;
							while (name[i] != '=' && name[i])
								i++;
							if (name[i]) {
								name[i] = 0;

								// q3 fix
								if (strcmp(name+4,"Type") == 0 && strcmp(name+i+1,"14") == 0)
									strcpy(name+i+1,"6");

								HashInsert(newlist,"Extra",name+4,name+i+1,HASH_STRING);
							}
						}
					} else {
						ServersListUpdateEnable(0);
						fgets(ipaddr, 128, in);
						strip(ipaddr);
						//fscanf(in, "%d\n", &type);
						fscanf(in,"%s\n",qstat_type);
						
						// q3 fix
						//if (type == 14)
						//	type = 6;

						AddServer(newlist, NewServer(name,ipaddr,qstat_type));
						ServersListUpdateEnable(1);
					}
				}
			}
		fclose(in);
		}
	
	DestroyWindow(hwnd);
	return 1;
}

void LoadFromDisk(void)
{
	int newver;
	int i,j,end;
	char* cmd;
	char file[256];

	HashInsertInt(HASH_GLOBAL,"Global","ConfigLoaded",1);

	ServersListUpdateEnable(0);
	
	if (!(newver = LoadFileFromDisk("default.sq",1,1,1,1)) &&
		!LoadFileFromDisk("query.dat", 1,1,1,0) ) 
	{
		MOTD_NEW_Download(NULL);

#ifndef NOWELCOME
		MSG_DialogBox(NULL,NULL,NULL,IDD_WELCOME);
#endif
		CreateList("Internet","NetServers",NULL);
		//newlist = CreateList("PowerUp","QStatList",NULL);
		//HashInsert(newlist,"Extra","URL", "http://serverquery.qgl.org/powerup/",HASH_STRING);
	}
	if (!newver) {
		LoadFileFromDisk("servers.dat", 0,0,0,1);
		LoadFileFromDisk("powerup.dat", 0,0,0,1);
	}

	if (strcmp(cmd = HashSelectText(HASH_GLOBAL,"Global","Cmdline"),"") )
	{
		for (i=0;i<(int) strlen(cmd);i++)
		{
			end= ' ';
			if (cmd[i] == '"') {
				end = '"';
				i++;
			}
			strcpy(file,cmd+i);
			for (j=i;j<(int)strlen(cmd);j++)
				if (cmd[j] == end)
					break;
			file[j-i] = 0;
			
			LoadFileFromDisk(file,1,1,1,1);
			i = j;
			if (end = '"') 
				end++;
		}
	}
	ServersListUpdateEnable(1);
	ServersListUpdate(0);
}


void FullListName(list_t* list, char* str)
{
	char buf[2048];
	if (!HashSelectPtr(list,"ptrs","parent")) {
		sprintf (buf, "%s%s",list->desc,str);
		strcpy(str,buf);
		return;
	}
	sprintf (buf,"\034%s%s",list->desc,str);
	strcpy(str,buf);
	FullListName(HashSelectPtr(list,"ptrs","parent"),str);
	return;
}

void SaveFileToDisk(char* filename, int serversonly, list_t* unused)
{
	FILE* out;
	server_t *temp;
	char name[128];
	char fullname[2048];
	int i, number;
	HASH* hash, *buddy;
	int svrnum = 0;
	list_t* list;

	if ((out = fopen(filename, "wt")) != NULL)
	{
		fprintf(out, QUERY_VERSION "\n");

	  if (!serversonly) {
		  SaveWindowPosition(PROG_HWND);
		fprintf(out, "\n[SETTINGS]\n");
		// fixme - should use funcs to traverse the array 
		hash = HashGet(HASH_GLOBAL,"Settings");
		buddy = HashGet(HASH_GLOBAL,"Buddy");
		fprintf(out, "%d\n",hash->num + buddy->num);
		for (i=0;i<hash->num;i++)
			fprintf(out, "%s\n%s\n",hash->entries[i]->key,hash->entries[i]->value);
		for (i=0;i<buddy->num;i++)
			fprintf(out, "buddy\n%s\n",buddy->entries[i]->value);


		fprintf(out, "\n[PATHS]\n");

		number = 0;
		for (i=0;i<MAX_SERVER_TYPES;i++)
			if (!GetServerType(i)->invalid)
				number++;
		fprintf(out, "%d\n", number);


		for (i=0;i<MAX_SERVER_TYPES;i++)
			if (!GetServerType(i)->invalid)
				fprintf(out, "%s\n%s\n",GetServerType(i)->gamespy_type,GetServerType(i)->path);

		fprintf(out,"\n[PARAMETERS]\n");
		fprintf(out,"%d\n",number);
		for (i=0;i<MAX_SERVER_TYPES;i++)
			if (!GetServerType(i)->invalid)
				fprintf(out, "%s\n%s\n",GetServerType(i)->gamespy_type,GetServerType(i)->parameters);
	  }

	    list = HashReset(HASH_GLOBAL,"Lists",HASH_PTR);
		while (list)
		{
			if (HSI(list,"extra","unsavablelist") == 1)
			{
				list = HashNext(HASH_GLOBAL,"Lists",HASH_PTR);
				continue;
			}

			// This stops us from saving lan sublists at all
			
			if (strcmp(GroupOfList(list)->name, "LANServers") == 0
				&& HSP(list,"ptrs","parent"))
			{
				list = HashNext(HASH_GLOBAL,"Lists",HASH_PTR);
				continue;
			}
			

			strcpy(fullname, "");
			FullListName(list,fullname);
			fprintf(out, "\n[SERVERLIST_%s]\n\033\033\033\033TYPE=%s\n",fullname,GroupOfList(list)->name);
			if ((hash = HashExists(list,"extra")) != NULL) {
				for (i=0;i<hash->num;i++)
					fprintf(out, "\033\033\033\033%s=%s\n",hash->entries[i]->key,hash->entries[i]->value);
			}

			if (strcmp(GroupOfList(list)->name,"LANServers") == 0 ||
				strcmp(GroupOfList(list)->name,"ListAllServers") == 0) {
				list = HashNext(HASH_GLOBAL,"Lists",HASH_PTR);
				continue;
			}
			
			temp = HashReset(list,"Servers",HASH_PTR);
			while (temp) {
				if (temp->ipaddr[0]) {
					strcpy(name,temp->name);
					if (!name[0])
						strcpy(name,"New Server");
					fprintf(out, "%s\n%s\n%s\n",name,temp->ipaddr, temp->gametype->qstat_type);
				}
				temp = HashNext(list,"Servers",HASH_PTR);

			}
			list = HashNext(HASH_GLOBAL,"Lists",HASH_PTR);
		}
		fclose(out);
	}
	return;
}

void SaveToDisk(void) {
	if (HashSelectInt(HASH_GLOBAL,"Global","ConfigLoaded"))
		SaveFileToDisk("default.sq",0,NULL);
}

void DISK_OpenFile()
{
	OPENFILENAME ofn;
	static char filename[300];
	static char spec[128];
	static char dir[256];
	int i;

	strcpy(dir, GetCommandLine());

	if (dir[0] == '"')
		strcpy(dir,dir+1);

	for (i=0;i<(int)strlen(dir);i++)
		if (!memcmp(dir+i,".exe",4))
			break;

	for (;i>0;i--)
		if (dir[i] == '\\')
			break;

	strcpy(dir+i,"");

	memcpy(spec, "Configuration files\0*.SQ\0All files\0*.*\0",40);

	strcpy(filename, ""); 
	ZeroMemory(&ofn,sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = PROG_HWND;
	ofn.lpstrFilter = spec;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = filename;
	ofn.lpstrInitialDir = dir;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrTitle = "Open configuration file";
	
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR | OFN_HIDEREADONLY;
	if (GetOpenFileName(&ofn) == TRUE) 
		LoadFileFromDisk(ofn.lpstrFile,1,1,1,1);

	return;
}

void DISK_SaveFile(void)
{
	OPENFILENAME ofn;
	static char filename[300];
	static char spec[128];
	static char dir[256];
	int i;

	strcpy(dir, GetCommandLine());

	if (dir[0] == '"')
		strcpy(dir,dir+1);

	for (i=0;i<(int)strlen(dir);i++)
		if (!memcmp(dir+i,".exe",4))
			break;

	for (;i>0;i--)
		if (dir[i] == '\\')
			break;

	strcpy(dir+i,"");

	memcpy(spec, "Configuration files\0*.sq\0All files\0*.*\0",40);

	strcpy(filename, ""); 
	ZeroMemory(&ofn,sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = PROG_HWND;
	ofn.lpstrFilter = spec;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = filename;
	ofn.lpstrInitialDir = dir;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrTitle = "Save configuration file";
	ofn.lpstrDefExt = "sq";

	ofn.Flags = OFN_PATHMUSTEXIST | OFN_NOCHANGEDIR | OFN_OVERWRITEPROMPT;
	if (GetSaveFileName(&ofn) == TRUE) {
		SaveFileToDisk(ofn.lpstrFile,0,NULL);
	}
	return;
}

void WriteQSTAT(list_t* list, FILE* out)
{
	server_t* temp;
	int i;
	char name[128];
	list_t* other;

	if (list && strcmp(GroupOfList(list)->name,"LANServers") == 0)
		return;

	for (i=0; i<HashCount(HASH_GLOBAL,"Lists");i++)
	{
		other = HashSelectPtr(HASH_GLOBAL,"Lists",(HASH_PARAM)i);

		if (HashSelectPtr(other,"ptrs","parent") == list)
			WriteQSTAT(other,out);
	}

	if (!list)
		return;

	temp = HashReset(list,"Servers",HASH_PTR);
	while (temp) {
		if (temp->ipaddr[0]) {
			strcpy(name,temp->name);
			if (!name[0])
				strcpy(name,"New Server");
			fprintf(out, "%s %s \t# %s\n",temp->gametype->qstat_type, temp->ipaddr, name);
		}
		temp = HashNext(list,"Servers",HASH_PTR);
	}
	return;
}

void DISK_ExportQstatList(list_t* export)
{
	OPENFILENAME ofn;
	static char filename[300];
	static char spec[128];
	static char dir[256];
	FILE* out;
	int i;

	strcpy(dir, GetCommandLine());

	if (dir[0] == '"')
		strcpy(dir,dir+1);

	for (i=0;i<(int)strlen(dir);i++)
		if (!memcmp(dir+i,".exe",4))
			break;

	for (;i>0;i--)
		if (dir[i] == '\\')
			break;

	strcpy(dir+i,"");

	memcpy(spec, "QSTAT files\0*.qst\0All files\0*.*\0",40);

	strcpy(filename, ""); 
	ZeroMemory(&ofn,sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = PROG_HWND;
	ofn.lpstrFilter = spec;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = filename;
	ofn.lpstrInitialDir = dir;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrTitle = "Export QSTAT file";
	ofn.lpstrDefExt = "qst";

	ofn.Flags = OFN_PATHMUSTEXIST | OFN_NOCHANGEDIR | OFN_OVERWRITEPROMPT;
	if (GetSaveFileName(&ofn) != TRUE) 
		return;

	out = fopen(ofn.lpstrFile,"wt");
	WriteQSTAT(export,out);
	fclose(out);	

	return;
}