// *** Function definitions ***

// Server operations
extern server_t*		(*MAIN_NewServer)			(char* name, char* ipaddr, char* qstat_type);
extern server_t*		(*MAIN_AddServer)			(list_t* list, server_t* svr);
extern void			(*MAIN_DeleteServer)		(server_t* server, list_t* list);
extern types_t*		(*MAIN_GetServerType)		(int type);
extern types_t*		(*MAIN_GetServerType_qstat)		(char* type);

// List operations
extern void			(*MAIN_ServersListUpdate)	(int forced);
extern void			(*MAIN_EmptyList)			(list_t* list);
extern list_t*			(*MAIN_ListNamedWithParent)	(char* name, list_t* parent);
extern list_t*			(*MAIN_CreateList)			(char* desc, char* group, list_t* parent);
extern group_t*		(*MAIN_GroupOfList)			(list_t* list);
extern void			(*MAIN_ListPingAllServers)	(list_t*);

// Hash operations
extern HASH*			(*MAIN_HashAlloc)			(void* owner, char*name, int size);

// HTTP/Events 
extern void			(*MAIN_HTTP_Download)		(HTTP_DATA* data);
extern void			(*MAIN_EVENTS_Register)		(void (*func)(void*),void* ptr, float length, int repeat);

// Memory operations
extern void*			(*MAIN_calloc)				(size_t,size_t);
extern void*			(*MAIN_malloc)				(size_t);
extern void*			(*MAIN_realloc)				(void*,size_t);

// IP/port manipulation
extern unsigned long	(*MAIN_GetServerAddr)		(char* addr);
extern short int		(*MAIN_GetServerPort)		(char* addr, short otherwise);

void FUNC_Import(void);
void FUNC_Export(void);