/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
// find*
#include <windows.h>
#include <io.h>
#include <stdio.h>


#include "servers.h"
#include "list.h"


//#include "qstatlist.h"
//#include "q3master.h"
//#include "gspylist.h"

#include "events.h"

#include "hashdef.h"
#include "groupshared.h"

#include "main.h"

void RegisterGroupTypes(void) {
int handle;
	HMODULE dll;
	struct _finddata_t fd;
	char filename[256];
	char tmp[256];

	group_t def;
	group_shared_t info;
	
	group_t* groups[16];
	int i, j;
	
	int (__stdcall *Init)(group_shared_t*);

	info.hashes = G_Hashes;
	info.numHashes = &G_NumHashes;

	// Provide a 'default' type
	def.add_server = ListAddServer;
	def.delete_server = DeleteServer;
	def.cut_server = ServerCut;
	def.copy_server = ServerCopy;
	def.paste_server = ServerPaste;
	def.add_favourites = ServerAddFavourites;
	def.pastable_server = ServerPastable;
	def.delete_list = DeleteList;
	def.properties_list = RenameList;
	def.refresh_list = EmptyList;

	info.def = &def;

	if (PROG_HINSTANCE == NULL)
	{
		WRITE_DEBUG("Prog_HWND undefined (4).");
		ShutDown();
		exit(0);
	}

	handle = _findfirst("list/*.dll",&fd);

	if (handle != -1)
	{
		do {
			sprintf(filename,"list/%s",fd.name);
			sprintf(tmp,"Load: %s",filename);
			WRITE_DEBUG(tmp);

			if ((dll = LoadLibrary(filename)) != NULL)
			{
				HashInsertPtr(HASH_GLOBAL,"Status","hInstance",dll);
				Init = (int (__stdcall *)(group_shared_t*)) GetProcAddress(dll, "Init");
				if (Init)  {
					for (i=0;i<16;i++) 
						groups[i] = calloc(1,sizeof(group_t));
						
					info.groups = groups;
		
					WRITE_DEBUG("Init: DLL");
					j = Init(&info);

					for (i=0;i<j;i++)
						HashInsertPtr(HASH_GLOBAL,"Groups",HASH_ANY,groups[i]);

					for (;i<16;i++) 
						free(groups[i]);

				}
			}
		} while (! _findnext(handle,&fd) );
		_findclose(handle);
	}

	if (PROG_HINSTANCE == NULL)
	{
		WRITE_DEBUG("Prog_HWND undefined (3).");
		ShutDown();
		exit(0);
	}
	return;

}

void FreeGroupTypes(void) {
	group_t* grp;
	while ((grp = HashReset(HASH_GLOBAL,"Groups",HASH_PTR)) != NULL)
	{
		if (grp->shutdown)
			grp->shutdown(grp);
		else
			free(grp);
		HashDeleteValue(HASH_GLOBAL,"Groups",grp,HASH_PTR);
	}
	return;
}