void AddListType(char* desc, char* list);
void RemoveListType(char* list);

typedef struct group_s group_t;
typedef struct list_s list_t;

struct group_s {
	char name[128];
	char desc[128];

//	HASH* extra;
	void (*add_server)(list_t*);
	void (*delete_server)(server_t*,list_t*);
	void (*refresh_list)(list_t*);
	void (*delete_list)(list_t*);
	void (*properties_list)(list_t*);
	void (*cut_server)(server_t*);
	void (*copy_server)(server_t*);
	void (*paste_server)(list_t*);
	int  (*pastable_server)(list_t*);
#ifdef _WINSOCKAPI_
	int  (*is_packet_for)(list_t*,SOCKADDR* addr);
#else
	int  (*is_packet_for)(list_t*,void* addr);
#endif
	void (*packet)(list_t*,char* data, int len);
	void *location;
	void (*shutdown)(group_t*);
	void (*every_update)(list_t*);
	void (*major_update)(list_t*);
	void (*add_favourites)(server_t*);
	
};

#define GROUP_T

struct list_s {
	char desc[128];
//	HASH* servers; // unnamed DArray
	group_t group;
	void* hTreeItem;
	//list_t* parent;
//	HASH* extra;
	
};
#define LIST_T

// Function to grab the list_t of the specified list (from the "Lists" hash)
//list_t* ListNamed(char* name);
// These functions grabs the group_t for the specified group or list
group_t* GroupNamed(char* name);
//group_t* GroupOfListNamed(char* name);
group_t* GroupOfList(list_t* list);
list_t* ListNamedWithParent(char* name, list_t* parent);

// Creates a new list of specified group type, and returns the pointer to it.
list_t* CreateList(char* desc, char* group, list_t* parent);
void DeleteList(list_t* list);
void RenameList(list_t* list);

// Move lists on the treeview
void ListMoveUp(list_t* list);
void ListMoveDown(list_t* list);


// Delete's a list and then recreates it, meanings its now empty
void EmptyList(list_t* list);

// Dialog box to create a new list, via CreateList()
int CREATELIST_DialogBox(HINSTANCE hinstance, HWND hwnd);

// Dialog box to add a server to the specified list
void ListAddServer(list_t* list);

// This function rebuilds the treeview based on currently registered
// lists and servers
void ListRebuildTreeview(void);

// This function creates the image list used by the treeview.  It adds
// folder icons along with those supplied by the game DLLs.
void TreeviewImageList(char* name);
void StateImageList(char* name);

typedef struct {
	int type;
	void* ptr;
	void* owner;
} ITEM_TYPE;

#define IT_SERVER	1
#define IT_LIST		2
#define IT_ROOT		0