/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <windows.h>
#include <time.h>
#include <stdio.h>

#include "resource.h"
#include "stringtable.h"

#include "http.h"
#include "types.h"
#include "main.h"
#include "list.h"
#include "qstat.h" // type conversion
#include "utils.h"

//temp
#include "motd.h"

int WINAPI ONLINELISTS_DlgProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	char* name, *list;
	char type[128], url[128];
	char selname[128];
	int add, i;
	list_t* tmp;

	switch (msg) {
	case WM_INITDIALOG:
		name = strtok((char*)lparam,"\n");
		while (name)
		{
			add = 1;
			HIT(hwnd,"name",HASH_ANY,name);
			list = strtok(NULL,"\n");
			HIT(hwnd,"info",HASH_ANY,list);

			sscanf(list,"%s",type);
			if (SQstricmp(type,"QSTATLIST") == 0)
			{
				sscanf(list, "%*s %s",url);
				for (tmp = HashReset(HASH_GLOBAL,"lists",HASH_PTR);tmp;
						tmp = HashNext(HASH_GLOBAL,"lists",HASH_PTR))
				{
					if (SQstricmp(GroupOfList(tmp)->name,type) ==0 &&
						SQstricmp(HST(tmp,"extra","url"),url) == 0)
					{
					  add = 0;
					  break;
					}
				}
			}
			/*
			else if (SQstricmp(type,"GSPYMASTER") == 0)
			{
				sscanf(list,"%*s %s %s",gametype,url);
				gameid = GetServerType_qstat(gametype)->type;
				
				for (tmp = HashReset(HASH_GLOBAL,"lists",HASH_PTR);tmp;
						tmp = HashNext(HASH_GLOBAL,"lists",HASH_PTR))
				{
					if (SQstricmp(GroupOfList(tmp)->name,type) == 0 &&
						HSI(tmp,"extra","type") == gameid)
						  add = 0;
				}
			}*/

			if (add)
				SendMessage(GetDlgItem(hwnd,IDL_LISTS),LB_ADDSTRING,0,(LPARAM)name);
			name = strtok(NULL,"\n");
		}
		if (HSIG("settings","updateonlinelists"))
			SendMessage(GetDlgItem(hwnd,IDC_AUTO),BM_SETCHECK,BST_CHECKED,0);
		break;
	}
	if ((msg == WM_COMMAND && wparam == IDB_ADDLIST) ||
		(msg == WM_COMMAND && HIWORD(wparam) == LBN_DBLCLK))
	{
		i = SendMessage(GetDlgItem(hwnd,IDL_LISTS),LB_GETCURSEL,0,0);
		SendMessage(GetDlgItem(hwnd,IDL_LISTS),LB_GETTEXT,i,(long)selname);
		SendMessage(GetDlgItem(hwnd,IDL_LISTS),LB_DELETESTRING,i,0);

		for (i=0;i<HashCount(hwnd,"name");i++)
		{
			name = HashSelectText(hwnd,"name",(HASH_PARAM)i);

			if (SQstricmp(selname,name) == 0)
			{
				list = HashSelectText(hwnd,"info",(HASH_PARAM)i);
				sscanf(list,"%s",type);
				tmp = CreateList(name,type,NULL);
				if (tmp && SQstricmp(type,"QSTATLIST") == 0)
				{
					sscanf(list,"%*s %s",url);
					HIT(tmp,"extra","url",url);
				}
				/*
				else if (tmp && SQstricmp(type,"GSPYMASTER") == 0)
				{
					sscanf(list,"%*s %s %s",gametype,url);
					HII(tmp,"extra","type",GetServerType_qstat(gametype)->type);
					HIT(tmp,"extra","url",url);
				}
				*/

				if (GroupOfList(tmp)->refresh_list)
					HIP(hwnd,"refresh",HASH_ANY,tmp);
				break;
			}
		}
	}

	if ((msg == WM_COMMAND && wparam == IDOK) || msg == WM_CLOSE) 
	{
		
		EndDialog(hwnd,0);
		for (tmp = HashReset(hwnd,"refresh",HASH_PTR);tmp;
				tmp = HashNext(hwnd,"refresh",HASH_PTR))
			GroupOfList(tmp)->refresh_list(tmp);
		HashFreeAssoc(hwnd);
		HIIG("settings","updateonlinelists",
			SendMessage(GetDlgItem(hwnd,IDC_AUTO),BM_GETCHECK,0,0));
	}
	return 0;
}

void ONLINELISTS_AutoAdd(char* lparam)
{
	char* name;
	char* list;
	char type[128], url[128];
	int add;
	list_t* tmp;


	name = strtok((char*)lparam,"\n");
	while (name)
	{
		add = 1;
		list = strtok(NULL,"\n");
	
		sscanf(list,"%s",type);
		if (SQstricmp(type,"QSTATLIST") == 0)
		{
			sscanf(list, "%*s %s",url);
			for (tmp = HashReset(HASH_GLOBAL,"lists",HASH_PTR);tmp;
					tmp = HashNext(HASH_GLOBAL,"lists",HASH_PTR))
			{
				if (SQstricmp(GroupOfList(tmp)->name,type) ==0 &&
					SQstricmp(HST(tmp,"extra","url"),url) == 0)
				{
				  add = 0;
				  break;
				}
			}
		}
		/*
		else if (SQstricmp(type,"GSPYMASTER") == 0)
		{
			sscanf(list,"%*s %s %s",gametype,url);
			gameid = GetServerType_qstat(gametype)->type;
			
			for (tmp = HashReset(HASH_GLOBAL,"lists",HASH_PTR);tmp;
					tmp = HashNext(HASH_GLOBAL,"lists",HASH_PTR))
			{
				if (SQstricmp(GroupOfList(tmp)->name,type) == 0 &&
					HSI(tmp,"extra","type") == gameid)
					  add = 0;
			}
		}
		*/
		if (add)
		{
			// add list
			tmp = CreateList(name,type,NULL);
			if (tmp && SQstricmp(type,"QSTATLIST") == 0)
			{
				HIT(tmp,"extra","url",url);
			}
			/*
			else if (tmp && SQstricmp(type,"GSPYMASTER") == 0)
			{
				HII(tmp,"extra","type",GetServerType_qstat(gametype)->type);
				HIT(tmp,"extra","url",url);
			}*/
			if (GroupOfList(tmp)->refresh_list)
				GroupOfList(tmp)->refresh_list(tmp);

		}
		name = strtok(NULL,"\n");
	}
}

void ONLINELISTS_DialogBox(char* str) {
	DialogBoxParam(NULL,MAKEINTRESOURCE(IDD_ONLINELISTS),
		PROG_HWND,ONLINELISTS_DlgProc,(LPARAM)str);
	return;
}

void ONLINELISTS_Receive(HTTP_DATA* data) {
	
	int i;
	char* str;
	char* search = "\r\nLast-Modified: ";
	char date[128];
	char *temp;
	int autocheck = 0;

	for (str = data->header;memcmp(str,"\r\n\r\n",4);str++)
		if (memcmp(str,search,strlen(search)) == 0) {
			memcpy(date,str+strlen(search),120);
			for (i=0;i<120;i++)
				if (date[i] == '\r') {
					date[i] = 0;
					break;
				}
			temp = HashSelect(HASH_GLOBAL,"Settings","LastONLINELISTS",HASH_STRING);
			
			autocheck = HSIG("Status","CheckOnlineLists");
			HashDelete(HASH_GLOBAL,"Status","CheckOnlineLists");

			if (!autocheck || strcmp(date,temp))
			{
				
				//if (strlen(temp))
#ifdef AUTOADDLISTS
				if (autocheck)
					ONLINELISTS_AutoAdd(data->data);
				else 
					ONLINELISTS_DialogBox(data->data);
#else
				ONLINELISTS_DialogBox(data->data);
#endif
				
				HashInsert(HASH_GLOBAL,"Settings","LastONLINELISTS",date,HASH_STRING);
				return;
			}
		}
	return;
}

void ONLINELISTS_Download(void* unused)
{
	HTTP_DATA* data;
	static char listurl[128];
	(void*)unused;

	WRITE_DEBUG("ONLINELISTS: download");
	data = calloc(sizeof(HTTP_DATA),1);

	// On initial invocation, return if auto-update is disabled
	if (!unused)
	{
		if (HSIG("settings","updateonlinelists") == 0)
			return;

		HIIG("Status","CheckOnlineLists",1);
	}

	//LoadString(PROG_HINSTANCE,IDS_LISTURL,listurl,128);
	
	data->windowed = (int)unused;
	data->url = IDS_LISTURL; //listurl;
	data->func = ONLINELISTS_Receive;
	data->ptr = NULL;
	HTTP_Download(data);
}

