/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include "resource.h"
#include <windows.h>
#include "servers.h"
#include <stdio.h>
#include "main.h"

char* name;

int WINAPI PARAM_DlgProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	char user_param[128];

	switch (msg) {
	case WM_INITDIALOG:
		sprintf (user_param,"Connecting to '%s'",name);
		SendMessage(hwnd,WM_SETTEXT,0,(LPARAM)user_param);
		SetDlgItemText(hwnd,IDT_NAME,"Parameters:");
		break;
	case WM_COMMAND:
		if (wparam == IDOK) {
			GetDlgItemText(hwnd,IDT_PASSWORD,user_param,128);
			HashInsert(HASH_GLOBAL,"Status","Param",user_param,HASH_STRING);
			EndDialog(hwnd,1);
		}
		else if (wparam == IDCANCEL) {
			EndDialog(hwnd,0);
		}
		return 0;
	case WM_CLOSE:
		EndDialog(hwnd,0);
	}
	return 0;
}

int PARAM_DialogBox(void)
{
	HashDelete(HASH_GLOBAL,"Status","Param");
	name = CURRENT_SERVER->name;
	return DialogBox(PROG_HINSTANCE,MAKEINTRESOURCE(IDD_EDIT),PROG_HWND,PARAM_DlgProc);
}
