/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <stdio.h>

#include "resource.h"
#include "types.h"
#include "main.h"
#include "limits.h"

int PROGCFG_Close(HWND hwnd) 
{
	void* svr;

	DestroyWindow(hwnd);
	svr = HSPG("Status","ProgErrorRejoin");
			HashDelete(HASH_GLOBAL,"Status","ProgErrorRejoin");
			if (svr != NULL)
				ConnectServer(svr);
	
	return 0;
}			

HANDLE hinst;

char* current_path, *current_param;
	
void BrowseWindow(HWND hwnd)
{
	OPENFILENAME ofn;
	static char filename[300];
	static char spec[128];

	memcpy(spec, "Executables\0*.EXE;*.BAT\0All files\0*.*\0",40);

	strcpy(filename, current_path);
	ZeroMemory(&ofn,sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hwnd;
	ofn.lpstrFilter = spec;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = filename;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrTitle = "Select your program";
	
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;
	if (GetOpenFileName(&ofn) == TRUE) {
		strcpy(current_path, ofn.lpstrFile);
		SetDlgItemText(hwnd, IDT_PATH, ofn.lpstrFile);
	}
	return;
}

int WINAPI PROGCFG_DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int i, which;
	char buf[128];

	switch (msg) {
		case WM_COMMAND:
			if (wParam == IDC_BROWSE)
			{
				BrowseWindow(hwnd);
			}
			if (LOWORD(wParam) == IDC_GAME && HIWORD(wParam) == LBN_SELCHANGE)
			{
				which = SendMessage(GetDlgItem(hwnd, IDC_GAME), CB_GETCURSEL, 0, 0);
				SendMessage(GetDlgItem(hwnd,IDC_GAME),CB_GETLBTEXT,which,(LPARAM)buf);
				for (i=0;i<MAX_SERVER_TYPES;i++) {
					if (strcmp(GetServerType(i)->name,buf) == 0) 
						break;
				}
				if (i!=MAX_SERVER_TYPES) {
					SendMessage(GetDlgItem(hwnd, IDT_PATH), WM_SETTEXT, 0, (LPARAM)(current_path = GetServerType(i)->path));
					SendMessage(GetDlgItem(hwnd, IDT_PARAMETERS), WM_SETTEXT, 0, (LPARAM)(current_param = GetServerType(i)->parameters));
				}
			}
			else if (LOWORD(wParam) == IDT_PATH && HIWORD(wParam) == EN_KILLFOCUS)
				SendMessage(GetDlgItem(hwnd, IDT_PATH), WM_GETTEXT, 128, (LPARAM)current_path);

			else if (LOWORD(wParam) == IDT_PARAMETERS && HIWORD(wParam) == EN_KILLFOCUS)
				SendMessage(GetDlgItem(hwnd,IDT_PARAMETERS),WM_GETTEXT,128,(LPARAM)current_param);
			if (LOWORD(wParam) == IDB_OK)
				return PROGCFG_Close(hwnd);
			return 0;
		case WM_CLOSE:
			PROGCFG_Close(hwnd);
			return 0;
	}
	return 0;
}


void PROGCFG_DialogBox(void)
{
	int i;
	char* first;
	HWND hwnd;
	server_t* svr;

	hwnd = CreateDialog(PROG_HINSTANCE, MAKEINTRESOURCE(IDD_PROGCFG), PROG_HWND, PROGCFG_DlgProc);
	
	for (i=0;i<MAX_SERVER_TYPES;i++)
		if (!GetServerType(i)->invalid && !GetServerType(i)->disallowPath) {
			SendMessage(GetDlgItem(hwnd, IDC_GAME), CB_ADDSTRING, strlen(GetServerType(i)->name), (LPARAM)GetServerType(i)->name);
			//if (first == -1)
			//	first =  i;
		}

	svr = CURRENT_SERVER;

	if (svr && svr->gametype)
		first = svr->gametype->qstat_type;

	else first = GetServerType(1)->qstat_type;

	if (first)
	{
		SendMessage(GetDlgItem(hwnd, IDC_GAME), CB_SELECTSTRING, -1, (LPARAM)GetServerType_qstat(first)->name);

		SendMessage(GetDlgItem(hwnd, IDT_PATH), WM_SETTEXT, 0, (LPARAM)(current_path = GetServerType_qstat(first)->path));
		SendMessage(GetDlgItem(hwnd, IDT_PARAMETERS), WM_SETTEXT, 0, (LPARAM)(current_param = GetServerType_qstat(first)->parameters));
	}


	ShowWindow(hwnd,SW_SHOW);
	return;
}
