/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <string.h>
#include "types.h"

#define BUF_SIZE 2048

int sq_stricmp(char* str1, char* str2)
{
	char buf1[BUF_SIZE], buf2[BUF_SIZE];
	int i;

	for (i=0;i<=(int)strlen(str1);i++)
		buf1[i] = (str1[i] >= 'A' && str1[i] <= 'Z' ? str1[i] + 32: str1[i]);

	for (i=0;i<=(int)strlen(str2);i++)
		buf2[i] = (str2[i] >= 'A' && str2[i] <= 'Z' ? str2[i] + 32: str2[i]);

	return strcmp(buf1,buf2);
}

typedef struct 
{
	char* qstat_id;
	char* gamespy_id;
	int sq_id;
} SQ_QSTAT;

static SQ_QSTAT ids[] = {
	{ "", 0 },		// default, none
	{ "QS", "quake1",	8 },	// Quake
	{ "H2S", "",		0 },	// Hexen 2
	{ "QWS", "quakeworld",3 },	// QuakeWorld
	{ "HWS", "",		0 },	// HexenWorld
	{ "Q2S", "quake2",	1 },	// Quake 2 
	{ "Q3S", "quake3",	6 },	// Quake 3 
	{ "UNS", "ut",		10},    // Unreal Tournament
	{ "UNS", "",		7 },	// Unreal
	{ "HLS", "halflife",4 },	// Half-Life
	{ "SNS", "",		2 },	// Sin
	{ "SGS", "",		0 },	// Shogo
	{ "TBS", "tribes",	5 },	// Tribes
	{ "T2S", "tribes2",	16 },	// Tribes
	{ "KPS", "",		9 },	// Kingpin
	{ "SFS", "",		12},	// Soldier Of Fortune
	{ "GRS", "",		15},	// Gore
	{ "RWS", "wolf",	17},	// Return to Wolf Demo
	{ "RWS", "wolf",	18},	// Return to Wolf
	{ "MDS", "mohaad",	19},	// MOHAA Demo
	{ "MHS", "mohaa",	20},	// MOHAA
								// Mohaa 1.0
	{ "SMS", "serioussam", 22}, // Serious Sam
	{ "S2S", "serioussam2", 23},	// Serious Sam 2
	{ "S2D", "serioussam2demo", 24}, // Serious Sam 2 Demo
	{ "RGD", "ccrenegadedemo", 25 },
	{  0,    0,			0 }
};


int ID_QSTATtoSQ(char* qstat)
{
	types_t type;
	int i;

	for (i=0;i<num_server_types;i++)
		if (sq_stricmp(server_types

	int i;
	for (i=0;ids[i].qstat_id;i++)
		if (sq_stricmp(ids[i].qstat_id,qstat) == 0)
			return ids[i].sq_id;
	return 0;
}

char* ID_SQtoQSTAT(int sq)
{
	int i;
	for (i=0;ids[i].qstat_id;i++)
		if (ids[i].sq_id == sq)
			return ids[i].qstat_id;
	return "";
}

char* ID_SQtoGAMESPY(int sq)
{
	int i;
	for (i=0;ids[i].qstat_id;i++)
		if (ids[i].sq_id == sq)
			return ids[i].gamespy_id;
	return "";
}

int ID_GAMESPYtoSQ(char* gamespy)
{
	int i;
	for (i=0;ids[i].qstat_id;i++)
		if (sq_stricmp(ids[i].gamespy_id,gamespy) == 0)
			return ids[i].sq_id;
	return 0;
}
