/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <stdio.h>
#include "resource.h"
#include "types.h"
#include "shared.h"
#include <time.h>
#include "quakex.h"
#include "main.h"
#include "quake3/resource.h"
#include "servinfo.h"

#define TYPE_Q3	6
#define TYPE_Q3127 14
#define TYPE_RTCW 18

#define TEAM other[0]

// obtained from the executable
SOCKET s;
char* clan_id;
unsigned long (*GetServerAddr)(char* addr);
short int (*GetServerPort)(char* addr, short otherwise);
types_t*		(*MAIN_GetServerType)		(int type);
types_t*		(*MAIN_GetServerType_qstat)		(char* type);
HWND mainhwnd;
HINSTANCE hinstance;

void QUAKE3_Send(SOCKET s, server_t* svr, short port) 
{
	SOCKADDR_IN src_addr;

	src_addr.sin_family = AF_INET;
	if (svr) {
		src_addr.sin_addr.s_addr = GetServerAddr(svr->ipaddr);
		src_addr.sin_port = htons(GetServerPort(svr->ipaddr, port));
	}
	else {
		src_addr.sin_addr.s_addr = INADDR_BROADCAST;
		src_addr.sin_port = htons(port);
	}
	
	sendto(s, "\xff\xff\xff\xffgetstatus", 14, 0, (SOCKADDR*)&src_addr, sizeof(SOCKADDR_IN));
	
	return;
}

void QUAKE3_PrintInfo(server_t* svr, HWND mainwnd, int ignore_changes)
{
//	player_t temp_p;
	HWND temp, hwnd; //, lv;
	//LV_ITEM lvi;
	//int id = 0, add;

	int i, j, num_players;
	char buf[128];
	int order[128];
	char teams[8][128];
	char teamscores[8][128];
	int teamcount[8];
	char* teamptr;
	int team;

	int sin = 0;

	hwnd = mainwnd;

	mainhwnd = mainwnd;

	/*lv = HashSelectPtr(HASH_GLOBAL,"Global","ServerInfoLV");

	if (HashSelectInt(HASH_GLOBAL,"Status","ServerInfoType") != svr->type)
	{
		add = 1;
		ListView_DeleteAllItems(lv);
		HashDeleteAll(HASH_GLOBAL,"ServerInfo");
	}
	else add = 0;

	HashInsertInt(HASH_GLOBAL,"Status","ServerInfoType",svr->type);

	memset(&lvi,0,sizeof(LV_ITEM));
	lvi.mask = LVIF_TEXT;*/
	ServinfoInit(svr);

	// == Set hostname == 
	sprintf(buf, "%s", GetValue(svr,"sv_hostname") );
	
	if (svr->timeout >= 5) {
		strcpy(buf, "UNREACHABLE");
		HashDeleteAll(svr,"items");		// wipe all current settings so we get blanks
		HII(svr,"info","num_players",0);
	} else if (HashCount(svr,"items") == 0) {
		HII(svr,"info","num_players",0);
		strcpy(buf, "CONNECTING...");
	}

	SetDlgItemText(hwnd, IDT_HOSTNAME, buf);
	ServinfoAdd("Hostname",buf);
	ServinfoAdd("Address", svr->ipaddr);

	// == Set version ==
	strcpy(buf,"");

	if (strcmp(svr->gametype->qstat_type,"Q3S") == 0) // svr->type == 6) // Quake3
	{
		if (strcmp(GetValue(svr, "protocol"),""))
		{
			sscanf(GetValue(svr, "protocol"), "%d", &i);
			switch (i) {
				case 35: strcpy(buf, "Q3Test  (v1.03)"); break;
				case 36: strcpy(buf, "Q3Test  (v1.05)"); break;
				case 38: strcpy(buf, "Q3Test  (v1.06)"); break;
				case 39: strcpy(buf, "Q3Test  (v1.07)"); break;
				case 43: strcpy(buf, "Quake3  (v1.09-v1.11)"); break;
				case 45: strcpy(buf, "Quake3  (v1.17)"); break;
				case 48: strcpy(buf, "Quake3  (v1.27)"); break;
				case 66: strcpy(buf, "Quake3  (v1.29)"); break;
				default: strcpy(buf, "Quake3");
			}
		}
		
	}
	else {
		strcpy(buf,svr->gametype->name);
	}
	/*if (svr->type == 17)
		strcpy(buf,"Return to Castle Wolfenstein Demo");
	else if (svr->type == 18)
		strcpy(buf,"Return to Castle Wolfenstein");
	else if (svr->type == 28)
		strcpy(buf,"Jedi Knight 2: Jedi Outcast");
	else if (svr->type == 29)
		strcpy(buf,"Soldier of Fortune II - Double Helix MP Test");
	else if (svr->type == 30)
		strcpy(buf,"Soldier of Fortune II - Double Helix");
		*/

	SetDlgItemText(hwnd,IDT_VERSION,buf);
	ServinfoAdd("Game",buf);

	// == Set mapname ==
	SetDlgItemText(hwnd, IDT_MAPNAME, GetValue(svr, "mapname") );
	ServinfoAdd("Map",GetValue(svr,"mapname") );
	
	// == Set num players ==
	strcpy(buf,"");
	if (strcmp(GetValue(svr, "sv_maxclients"), ""))
		sprintf(buf, "%d / %s", HSI(svr,"info","num_players"), GetValue(svr, "sv_maxclients") );
	SetDlgItemText(hwnd, IDT_PLAYERS, buf);
	ServinfoAdd("Players",buf);

	// == Set ping ==
	ServinfoAdd("Ping","");

	if (HSIG("Settings","ExtraServInfo") && _stricmp(GetValue(svr,"gamename"), "q3f") == 0)
	{
		ServinfoAdd("Red Team",GetValue(svr,"score_red") );
		ServinfoAdd("Blue Team",GetValue(svr,"score_blue") );
		ServinfoAdd("Green Team",GetValue(svr,"score_green") );
		ServinfoAdd("Yellow Team",GetValue(svr,"score_yellow") );
	}

  if (HSIG("Settings","ExtraServInfo"))
  {
	// == Set game/mod type ==
	SetDlgItemText(hwnd, IDC_DMFLAGS, "Game type:" );
	i = GetValue(svr,"g_gametype")[0] - '0';
	switch (i) {
		case 0: strcpy(buf, "Free For All" ); break;
		case 1: strcpy(buf, "1 on 1" ); break;
		case 4: strcpy(buf, "CTF" ); break;
		case 3: strcpy(buf, "Team DM" ); break;
		default: strcpy(buf, "FFA/Unknown" );
	}
	SetDlgItemText(hwnd,IDT_DMFLAGS,buf);
	ServinfoAdd("Game type",buf);

	// == Set fraglimit ==
	SetDlgItemText(hwnd, IDT_FRAGLIMIT, GetValue(svr, "fraglimit") );
	ServinfoAdd("Fraglimit",GetValue(svr,"fraglimit") );

	// == Set timelimit ==
	SetDlgItemText(hwnd, IDT_TIMELIMIT, GetValue(svr, "timelimit") );
	ServinfoAdd("Timelimit", GetValue(svr,"timelimit") );

	// == Set capturelimit ==
	SetDlgItemText(hwnd, IDC_CAPTURELIMIT, "Capturelimit:");
	SetDlgItemText(hwnd, IDT_CAPTURELIMIT, GetValue(svr, "capturelimit") );
	ServinfoAdd("Capturelimit", GetValue(svr,"capturelimit") );

	// == Set misc info ==
	SetDlgItemText(hwnd,IDT_MISC,"");
  }

	//
	// == print player list ==
	//
	temp = GetDlgItem(hwnd, IDL_PLAYERS);

	SendMessage(temp, LB_RESETCONTENT, 0, 0);
	
	
	num_players = HSI(svr,"info","num_players");

	for (i=0;i<num_players;i++)
		order[i] = i;


	i = 0;
	while (i < num_players - 1) 
	{
		if (HSI(svr,"frags",(HASH_PARAM)order[i]) < HSI(svr,"frags",(HASH_PARAM)order[i+1]))
		{
			j = order[i];
			order[i] = order[i+1];
			order[i+1] = j;
			i = 0;
			continue;
		}
		i++; 
	}
	
	SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)"\tFrags\tPing\tName");
	PlayerinfoInit(svr);

	// Q3F - god this is lazy programming
	if (_stricmp(GetValue(svr,"gamename"), "q3f") == 0 && (
		strcmp(GetValue(svr,"players_red"),"") != 0 ||
		strcmp(GetValue(svr,"players_blue"),"") != 0 ||
		strcmp(GetValue(svr,"players_green"),"") != 0 ||
		strcmp(GetValue(svr,"players_yellow"),"") != 0))
	{
		strcpy(teams[0],"Red Team");
		strcpy(teams[1],"Blue Team");
		strcpy(teams[2],"Green Team");
		strcpy(teams[3],"Yellow Team");
		strcpy(teams[4],"Spectators");

		strcpy(teamscores[0],GetValue(svr,"score_red"));
		strcpy(teamscores[1],GetValue(svr,"score_blue"));
		strcpy(teamscores[2],GetValue(svr,"score_green"));
		strcpy(teamscores[3],GetValue(svr,"score_yellow"));
		strcpy(teamscores[4],"-1000");
		teamcount[0] = teamcount[1] = teamcount[2] = teamcount[3] = teamcount[4] = 0;

		for (i=0;i<num_players;i++)
			HII(svr,"team",(HASH_PARAM)i,4);
		teamcount[4] = num_players;

		if (strcmp(teamptr = GetValue(svr,"players_red"),"") != 0)
		{
			while (*teamptr)
			{
				sscanf(teamptr,"%d",&i);
				teamcount[0] ++;
				teamcount[4] --;
				HII(svr,"team",(HASH_PARAM)i,0);

				while (*teamptr != ' ' && *teamptr) teamptr++;
				if (*teamptr == ' ') teamptr++;
			}
		}
		if (strcmp(teamptr = GetValue(svr,"players_blue"),"") != 0)
		{
			while (*teamptr)
			{
				sscanf(teamptr,"%d",&i);
				teamcount[1] ++;
				teamcount[4] --;
				HII(svr,"team",(HASH_PARAM)i,1);

				while (*teamptr != ' ' && *teamptr) teamptr++;
				if (*teamptr == ' ') teamptr++;
			}
		}

		for (team=0;team<=4;team++)
		{
			if (teamcount[team] == 0) continue;

			else sprintf(buf + strlen(buf), "%s\t\t%s", 
					teamscores[team],
					teams[team]
				);
				SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)buf);

				PlayerinfoAdd(teams[team],
					-3000 - atoi(teamscores[team]),
					0,
					-2000
				);
				

			for (i=0;i<num_players;i++)
			{
				if (HSI(svr,"team",(HASH_PARAM)order[i]) != team)
					continue;
			
					strcpy(buf,"");
	
				WRITE_DEBUG("memcmp() quake3.c(145)");
		
				strcat(buf, "\t");

				if (!ignore_changes && HSI(svr,"change",(HASH_PARAM)order[i]))
					sprintf(buf + strlen(buf), "%d (%c%d)\t%d\t%s", 
						HSI(svr,"frags",(HASH_PARAM)order[i]), 
						HSI(svr,"change",(HASH_PARAM)order[i]) > 0 ? '+' : ' ', 
						HSI(svr,"change",(HASH_PARAM)order[i]),
						HSI(svr,"ping",(HASH_PARAM)order[i]),
						HST(svr,"name",(HASH_PARAM)order[i])
					);
				else sprintf(buf + strlen(buf), "%d\t%d\t%s", 
					HSI(svr,"frags",(HASH_PARAM)order[i]),
					HSI(svr,"ping",(HASH_PARAM)order[i]),
					HST(svr,"name",(HASH_PARAM)order[i])
				);
				SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)buf);

				PlayerinfoAdd(HST(svr,"name",(HASH_PARAM)order[i]),
					HSI(svr,"frags",(HASH_PARAM)order[i]),
					//order[i],
					HSI(svr,"change",(HASH_PARAM)order[i]),
					HSI(svr,"ping",(HASH_PARAM)order[i])
				);
			}
		}
	}
		// for OSP - once again, really lazy programming
	else if(_stricmp(GetValue(svr,"gamename"), "osp") == 0 && (
		strcmp(GetValue(svr,"players_red"),"") != 0 ||
		strcmp(GetValue(svr,"players_blue"),"") != 0))
	{
		strcpy(teams[0],"Red Team");
		strcpy(teams[1],"Blue Team");
		strcpy(teams[4],"Spectators");

		strcpy(teamscores[0],GetValue(svr,"score_red"));
		strcpy(teamscores[1],GetValue(svr,"score_blue"));
		strcpy(teamscores[4],"-1000");
		teamcount[0] = teamcount[1] = teamcount[2] = teamcount[3] = teamcount[4] = 0;

		for (i=0;i<num_players;i++)
			HII(svr,"team",(HASH_PARAM)i,4);
		teamcount[4] = num_players;

		if (strcmp(teamptr = GetValue(svr,"players_red"),"") != 0)
		{
			while (*teamptr)
			{
				sscanf(teamptr,"%d",&i);
				teamcount[0] ++;
				teamcount[4] --;
				HII(svr,"team",(HASH_PARAM)(i-1),0);

				while (*teamptr != ' ' && *teamptr) teamptr++;
				if (*teamptr == ' ') teamptr++;
			}
		}
		if (strcmp(teamptr = GetValue(svr,"players_blue"),"") != 0)
		{
			while (*teamptr)
			{
				sscanf(teamptr,"%d",&i);
				teamcount[1] ++;
				teamcount[4] --;
				HII(svr,"team",(HASH_PARAM)(i-1),1);

				while (*teamptr != ' ' && *teamptr) teamptr++;
				if (*teamptr == ' ') teamptr++;
			}
		}

		for (team=0;team<=4;team++)
		{
			if (teamcount[team] == 0) continue;
			if (team == 2 ) team = 4;

			else sprintf(buf + strlen(buf), "%s\t\t%s", 
					teamscores[team],
					teams[team]
				);
				SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)buf);

				PlayerinfoAdd(teams[team],
					-3000 - atoi(teamscores[team]),
					0,
					-2000
				);
				

			for (i=0;i<num_players;i++)
			{
				if (HSI(svr,"team",(HASH_PARAM)order[i]) != team)
					continue;
			
					strcpy(buf,"");
	
				WRITE_DEBUG("memcmp() quake3.c(145)");
		
				strcat(buf, "\t");

				if (!ignore_changes && HSI(svr,"change",(HASH_PARAM)order[i]))
					sprintf(buf + strlen(buf), "%d (%c%d)\t%d\t%s", 
						HSI(svr,"frags",(HASH_PARAM)order[i]), 
						HSI(svr,"change",(HASH_PARAM)order[i]) > 0 ? '+' : ' ', 
						HSI(svr,"change",(HASH_PARAM)order[i]),
						HSI(svr,"ping",(HASH_PARAM)order[i]),
						HST(svr,"name",(HASH_PARAM)order[i])
					);
				else sprintf(buf + strlen(buf), "%d\t%d\t%s", 
					HSI(svr,"frags",(HASH_PARAM)order[i]),
					HSI(svr,"ping",(HASH_PARAM)order[i]),
					HST(svr,"name",(HASH_PARAM)order[i])
				);
				SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)buf);

				PlayerinfoAdd(HST(svr,"name",(HASH_PARAM)order[i]),
					HSI(svr,"frags",(HASH_PARAM)order[i]),
					//order[i],
					HSI(svr,"change",(HASH_PARAM)order[i]),
					HSI(svr,"ping",(HASH_PARAM)order[i])
				);
			}
		}
	}
	else {

		for (i=0;i<num_players;i++)
		{
			strcpy(buf,"");
	
			WRITE_DEBUG("memcmp() quake3.c(145)");
			if (strcmp(clan_id,""))
			{
				for (j=0;j<(int)(strlen(HST(svr,"name",(HASH_PARAM)order[i])) - strlen(clan_id));j++)
					if (!memcmp(HST(svr,"name",(HASH_PARAM)order[i]) + j, clan_id, strlen(clan_id)))
						strcat(buf,"*");
			}
		
			strcat(buf, "\t");

			if (!ignore_changes && HSI(svr,"change",(HASH_PARAM)order[i]))
				sprintf(buf + strlen(buf), "%d (%c%d)\t%d\t%s", 
					HSI(svr,"frags",(HASH_PARAM)order[i]), 
					HSI(svr,"change",(HASH_PARAM)order[i]) > 0 ? '+' : ' ', 
					HSI(svr,"change",(HASH_PARAM)order[i]),
					HSI(svr,"ping",(HASH_PARAM)order[i]),
					HST(svr,"name",(HASH_PARAM)order[i])
				);
			else sprintf(buf + strlen(buf), "%d\t%d\t%s", 
				HSI(svr,"frags",(HASH_PARAM)order[i]),
				HSI(svr,"ping",(HASH_PARAM)order[i]),
				HST(svr,"name",(HASH_PARAM)order[i])
			);
			SendMessage(temp, LB_ADDSTRING, 0, (LPARAM)buf);

			PlayerinfoAdd(HST(svr,"name",(HASH_PARAM)order[i]),
				HSI(svr,"frags",(HASH_PARAM)order[i]),
				HSI(svr,"change",(HASH_PARAM)order[i]),
				HSI(svr,"ping",(HASH_PARAM)order[i])
			);
		}
	}

	return;
}

char* QUAKE3_Hostname(server_t* svr)
{
	return GetValue(svr, "sv_hostname");
}

int QUAKE3_Receive(server_t* svr, char* buf, int len)
{
	int i, j;
	char *name;

	buf[len] = 0;
	DecodeString(svr, buf, len);

	if (memcmp(HST(svr,"items","version"),"Wolf",4) == 0)
	{
		if (HSI(svr,"items","protocol") >= 57)
			svr->gametype = MAIN_GetServerType_qstat("RWS"); // wolf release
		else svr->gametype = MAIN_GetServerType_qstat("RWD");	// Wolf demo
	}
	
	for (i=0;i<HSI(svr,"info","num_players");i++)
	{
		name = HST(svr,"name",(HASH_PARAM)i);

		for (j=0;j<(int) strlen(name) - 1;) 
			if (name[j] == '^' && name[j+1] != '^') //name[j+1] >= '1' && name[j+1] <= '7') 
				strcpy(name+j,name+j+2);
			else j++;
		if (name[strlen(name)-1] == '^')
			name[strlen(name)-1] = 0;
	}


	// Update available information
	HashInsertText(svr,"stats","map",
		HashSelectText(svr,"items","mapname"));
	HashInsertInt(svr,"stats","numplayers",
		HSI(svr,"info","num_players") );
	HashInsertText(svr,"stats","maxplayers",
		HashSelectText(svr,"items","sv_maxclients") );

	return 1; // update displayed info
}

int QUAKE3_IsFull(server_t* svr)
{
	if (HSI(svr,"info","num_players") &&
			HSI(svr,"info","num_players") == atoi( GetValue(svr, "sv_maxclients") ) )
		return 1;
	return 0;
}

char* QUAKE3_Cmdline(server_t* svr)
{
	static char string[256];
	strcpy(string,"");

	//if (svr->type != TYPE_RTCW && HashExistsKey(svr,"items","gamename")  != (HASH_PARAM)-1)
	//	sprintf(string+strlen(string),"+set fs_game %s ",HashSelectText(svr,"items","gamename") );

	// set passworf if there's one
	if (strcmp(HashSelect(HASH_GLOBAL,"Status","Password",HASH_STRING),"") != 0)
			sprintf(string+strlen(string)," +set password \"%s\"",HashSelect(HASH_GLOBAL,"Status","Password",HASH_STRING));

	// and connect
	sprintf (string+strlen(string),"+connect %s", svr->ipaddr);
	return string;
}

int __stdcall Init(shared_t* info)
{
	types_t* t;
	int type = 0;

	GetServerAddr = info->GetServerAddr;
	GetServerPort = info->GetServerPort;

	HashInit(info->hashes,info->numHashes);
	s = HashSelectInt(HASH_GLOBAL,"Global","Socket");
	clan_id = HashSelectText(HASH_GLOBAL,"Settings","ClanId");
	hinstance = HashSelectPtr(HASH_GLOBAL,"Status","hInstance");	

	MAIN_GetServerType = HashSelectPtr(HASH_GLOBAL,"Global","GetServerType");
	MAIN_GetServerType_qstat = HashSelectPtr(HASH_GLOBAL,"Global","GetServerType_qstat");

	t = info->types[type++];
	//t->type = 6;
	t->protocol = 1;
	t->port = 27960;
	strcpy(t->name, "Quake 3: Arena");
	strcpy(t->path, "C:\\Quake3\\Quake3.exe");
	strcpy(t->qstat_type, "Q3S");
	strcpy(t->gamespy_type, "q3prot");
	strcpy(t->mod_var,"gamename");
	t->mod_cvar = "gamename";
	
	t->receive = QUAKE3_Receive;
	t->print_info = QUAKE3_PrintInfo;
	t->send = QUAKE3_Send;
	t->hostname = QUAKE3_Hostname;
	t->isfull = QUAKE3_IsFull;

	return 1;

	t = info->types[type++];
	//t->type = 17;
	t->port = 27960;
	strcpy(t->name, "Return to Castle Wolfenstein Demo");
	strcpy(t->path, "C:\\Program Files\\Wolf MP Test\\wolf.exe");
	strcpy(t->qstat_type, "RWD");
	strcpy(t->gamespy_type, "wolf");
	
	t->receive = QUAKE3_Receive;
	t->print_info = QUAKE3_PrintInfo;
	t->send = QUAKE3_Send;
	t->hostname = QUAKE3_Hostname;
//	t->cmdline = QUAKE3_Cmdline;
	(void*)t->iImage = LoadBitmap(hinstance,MAKEINTRESOURCE(IDB_GAMEICON2));
	HashInsertPtr(t,"funcs","isfull",QUAKE3_IsFull);

	t = info->types[type++];
	//t->type = 18;
	t->port = 27960;
	strcpy(t->name, "Return to Castle Wolfenstein");
	strcpy(t->path, "C:\\Program Files\\Return to Castle Wolfenstein\\WolfMP.exe");
	strcpy(t->qstat_type, "RWS");
	strcpy(t->gamespy_type, "wolf");
	
	t->receive = QUAKE3_Receive;
	t->print_info = QUAKE3_PrintInfo;
	t->send = QUAKE3_Send;
	t->hostname = QUAKE3_Hostname;
//	t->cmdline = QUAKE3_Cmdline;
	(void*)t->iImage = LoadBitmap(hinstance,MAKEINTRESOURCE(IDB_GAMEICON2));
	HashInsertPtr(t,"funcs","isfull",QUAKE3_IsFull);

	t = info->types[type++];
	//t->type = 28;
	t->port = 28070;
	strcpy(t->name, "Jedi Knight 2: Jedi Outcast");
	strcpy(t->path, "C:\\Games\\Jedi Knight 2\\jk2mp.exe");
	strcpy(t->qstat_type, "J2S");
	strcpy(t->gamespy_type, "jediknight2");
	
	t->receive = QUAKE3_Receive;
	t->print_info = QUAKE3_PrintInfo;
	t->send = QUAKE3_Send;
	t->hostname = QUAKE3_Hostname;
//	t->cmdline = QUAKE3_Cmdline;
	(void*)t->iImage = LoadBitmap(hinstance,MAKEINTRESOURCE(IDB_GAMEICON3));
	HashInsertPtr(t,"funcs","isfull",QUAKE3_IsFull);

	/*t = info->types[1];
	t->type = TYPE_Q3127;
	t->port = 27960;
	strcpy(t->name, "Quake 3: Arena (v1.27+)");
	strcpy(t->path, "C:\\Quake3\\Quake3.exe");
	t->receive = QUAKE3_Receive;
	t->print_info = QUAKE3_PrintInfo;
	t->send = QUAKE3_Send;
	t->hostname = QUAKE3_Hostname;
	t->cmdline = QUAKE3_Cmdline;
	(void*)t->iImage = LoadBitmap(hinstance,MAKEINTRESOURCE(IDB_GAMEICON));
	HashInsertPtr(t,"funcs","isfull",QUAKE3_IsFull);
	*/

	t = info->types[type++];
	//t->type = 29;
	t->port = 20100;
	strcpy(t->name, "Soldier Of Fortune II: Double Helix MP Test");
	strcpy(t->path, "C:\\Program Files\\Soldier of Fortune II - Double Helix MP TEXT\\sof2mp-test.exe");
	strcpy(t->qstat_type, "SF2D");
	strcpy(t->gamespy_type, "sof2d");
	
	t->receive = QUAKE3_Receive;
	t->print_info = QUAKE3_PrintInfo;
	t->send = QUAKE3_Send;
	t->hostname = QUAKE3_Hostname;
//	t->cmdline = QUAKE3_Cmdline;
	(void*)t->iImage = LoadBitmap(hinstance,MAKEINTRESOURCE(IDB_GAMEICON4));
	HashInsertPtr(t,"funcs","isfull",QUAKE3_IsFull);

	t = info->types[type++];
	//t->type = 30;
	t->port = 20100;
	strcpy(t->name, "Soldier Of Fortune II: Double Helix");
	strcpy(t->path, "C:\\Program Files\\Soldier of Fortune II - Double Helix\\sof2mp.exe");
	strcpy(t->qstat_type, "SF2S");
	strcpy(t->gamespy_type, "sof2s");
	
	t->receive = QUAKE3_Receive;
	t->print_info = QUAKE3_PrintInfo;
	t->send = QUAKE3_Send;
	t->hostname = QUAKE3_Hostname;
//	t->cmdline = QUAKE3_Cmdline;
	(void*)t->iImage = LoadBitmap(hinstance,MAKEINTRESOURCE(IDB_GAMEICON5));
	HashInsertPtr(t,"funcs","isfull",QUAKE3_IsFull);

	return type;
}

