/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <stdio.h>
#include "types.h"
#include "players.h"

#define CURPLAYER(x) ((HASH_PARAM)HSI(x,"info","num_players"))

#define TYPE_QW		3
#define TYPE_SOF2	30
#define TYPE_SOF2TEST 29

void DecodeString(server_t* svr, char* str, int len)
{
	int which, pos;
	int i = 0;
	char key[128], value[128];
	
	int frags, ping;
	char name[128];

	char* ptr = str;
	if (svr) //  && svr->type != 13)
		HashDeleteAll(svr,"items");

	
	if (memcmp(str, "\xff\xff\xff\xff", 4))
		return; // Not a valid string
	ptr += 4;

	while (*ptr != '\\' && *ptr != 0) ptr++; // Move to the \'ed information

	if (*ptr == 0)
		return; // invalid string
	 
	pos = 0; which = -1; 
	do {
		if (*ptr == '\\' || *ptr == '\x0a')
		{
			if (which == 0) {
				key[pos] = 0;
				which = 1;
			}
			else if (which == 1) {
				value[pos] = 0;
				HashInsert(svr,"items",key,value,HASH_STRING);
				which = 0;
			}
			else which = 0;
			pos = 0;
		}
		else {
			if (*ptr == 27)
			{
				if (*(ptr+1) >= '0' && *(ptr+1) <= '9')
					ptr++;
			}
			else {
				if (which == 0) key[pos] = *ptr;
				else value[pos] = *ptr;
				pos++;
			}
		}
		ptr++;
	} while (*ptr != '\x0A' && *ptr);
	value[pos] = 0;
	HashInsert(svr,"items",key,value,HASH_STRING); // FIX ME: should be done in loop

	HII(svr,"info","num_players",0);
	//svr->num_players = 0;

	do {
		ptr++;
		if (*ptr != '\x0') {
			if (strcmp(svr->gametype->qstat_type,"QWS") == 0) // svr->type == TYPE_QW)
				sscanf(ptr, "%*d %d %*d %d",&frags,&ping);
			else if ((strcmp(svr->gametype->qstat_type,"SF2S") == 0) // svr->type == TYPE_SOF2 || svr->type == TYPE_SOF2TEST
					&& HashSelectInt(svr,"items","protocol") >= 2003)
				sscanf(ptr, "%d %d %*d",&frags,&ping); // teamid?
			else 
				sscanf(ptr, "%d %d", &frags, &ping);
			
			HII(svr,"frags",CURPLAYER(svr),frags);
			HII(svr,"ping",CURPLAYER(svr),ping);

			while (*ptr != ' ' && *ptr != 0) ptr++; // go to first space
			if (*ptr == 0)
				break;
			ptr++;
			while (*ptr != ' ' && *ptr != 0) ptr++; // go to second space
			if (*ptr == 0)
				break;

			if (strcmp(svr->gametype->qstat_type,"QWS") == 0) // svr->type == TYPE_QW Quakeworld uses another two numbers,
										// player# and time on server
			{
				ptr++;
				while (*ptr != ' ' && *ptr != 0) ptr++; // go to third space
				if (*ptr == 0)
					break;
				ptr++;
				while (*ptr != ' ' && *ptr != 0) ptr++; // go to second space
				if (*ptr == 0)
					break;
			}
			else if ((strcmp(svr->gametype->qstat_type,"SF2S") == 0) // svr->type == TYPE_SOF2 || svr->type == TYPE_SOF2TEST
					&& HashSelectInt(svr,"items","protocol") >= 2003)
			{
								ptr++;
				while (*ptr != ' ' && *ptr != 0) ptr++; // go to third space
				if (*ptr == 0)
					break;
			}

						
			ptr +=2; // " \""
			pos = 0;
			while (*ptr != '\"' && *ptr) {
				name[pos++] = *(ptr++);
				//FIXME: quake3 colored name hack
				if (name[pos-1] == 27)
				{
					if (*ptr >= '0' && *ptr <= '9')
						ptr++;
					pos--;
				}
				while ((int) name[pos-1] > 128)
					name[pos-1] -= 64;
			}
			name[pos] = 0;
			HIT(svr,"name",CURPLAYER(svr),name);

			HII(svr,"change",CURPLAYER(svr),
				HSI(svr,"frags",CURPLAYER(svr)) - SearchRecords(svr, (int)CURPLAYER(svr))
			);
			HII(svr,"info","num_players",(int) CURPLAYER(svr) + 1);
			ptr++; // skip \"

			while (*ptr && *ptr != '\n')
				ptr++;
		}
	} while (*ptr != '\x0');
	CleanRecords(svr);

	return;
}
