#include <windows.h>
#include <string.h>
#include <stdio.h>
#include "types.h"
#include "main.h"
#include "resource.h"


void GetExecutableName(char* str, int limit) {
	char *ptr;
	int i;
	
	strncpy(str,GetCommandLine(),limit);
	str[limit-1] = 0;

	if (str[0] == '"') {
		//ptr = str+1;
		for (i=1;str[i]!='"' && str[i];i++)
			;
		i++;
		str[i] = 0;
	}
	else {
		ptr = str;
		for (i=0;str[i] != ' ' && str[i];i++)
			;
		str[i] = 0;
	}
	
	//if (str != ptr)
	//	strcpy(str,ptr);
	return;
}
void SCHEME_AddEntries(void)
{
	int i, j;
	char keyname[64];
	char execname[512];
	char buf[128];
	char type[16];

	HKEY key;
	HKEY subkeys[7];

	GetExecutableName(execname,512);

	for (i=0;i<num_server_types;i++)
	{
		if (!*server_types[i]->qstat_type) continue;
		strcpy(type,server_types[i]->qstat_type);
		for (j=0;j<(int) strlen(type);j++) type[j] = tolower(type[j]);
		
		sprintf(keyname,"%s-game",type);
		
		// Create the key
		if (RegCreateKeyEx(HKEY_CLASSES_ROOT,keyname,0,"",0,KEY_ALL_ACCESS,NULL,&key,NULL)
			!= ERROR_SUCCESS) continue;

		// Set properties
		sprintf(buf,"URL:%s Protocol",type);
		RegSetValueEx(key,"",0,REG_SZ,buf,strlen(buf)+1);
		RegSetValueEx(key,"URL Protocol",0,REG_SZ,"",1);

		// Create shell subkey
		RegCreateKeyEx(key,"shell",0,"",0,KEY_ALL_ACCESS,NULL,&subkeys[0],NULL);

		// Create shell-open subkey
		RegCreateKeyEx(subkeys[0],"open",0,"",0,KEY_ALL_ACCESS,NULL,&subkeys[1],NULL);

		// Create shell-open-command subkey
		RegCreateKeyEx(subkeys[1],"command",0,"",0,KEY_ALL_ACCESS,NULL,&subkeys[2],NULL);
		sprintf(buf,"%s /min",execname);
		RegSetValueEx(subkeys[2],"",0,REG_SZ,buf,strlen(buf)+1);

		// Create shell-open-ddeexec subkey
		RegCreateKeyEx(subkeys[1],"ddeexec",0,"",0,KEY_ALL_ACCESS,NULL,&subkeys[3],NULL);
		sprintf(buf,"[server(\"%s\",\"%%1\")]",type);
		RegSetValueEx(subkeys[3],"",0,REG_SZ,buf,strlen(buf)+1);

		// Create shell-open-ddeexec-application
		RegCreateKeyEx(subkeys[3],"application",0,"",0,KEY_ALL_ACCESS,NULL,&subkeys[4],NULL);
		RegSetValueEx(subkeys[4],"",0,REG_SZ,"query",6);

		// Create shell-open-ddeexec-ifexec
		RegCreateKeyEx(subkeys[3],"ifexec",0,"",0,KEY_ALL_ACCESS,NULL,&subkeys[5],NULL);
		sprintf(buf,"[server(\"%s\",\"%%1\")][quit()]",type);
		RegSetValueEx(subkeys[5],"",0,REG_SZ,buf,strlen(buf)+1);

		// Create shell-open-ddeexec-topic
		RegCreateKeyEx(subkeys[3],"topic",0,"",0,KEY_ALL_ACCESS,NULL,&subkeys[6],NULL);
		RegSetValueEx(subkeys[6],"",0,REG_SZ,"system",7);
	}
	return;
}

void SCHEME_DeleteTree(HKEY parentkey, char* keyname)
{
	HKEY key;
	int i = 0;
	char subkeyname[128];
	int subkeylength;

	if (RegOpenKeyEx(parentkey,keyname,0,KEY_ALL_ACCESS,&key) != ERROR_SUCCESS)
			return; // key doesn't exist
	
	while (subkeylength = 128, RegEnumKeyEx(key,i,subkeyname,&subkeylength,NULL,NULL,NULL,NULL) == ERROR_SUCCESS)
	{
		SCHEME_DeleteTree(key,subkeyname);
		i++;
	}

	// Delete values
	i = 0;
	while (subkeylength = 128, RegEnumValue(key,i,subkeyname,&subkeylength,NULL,NULL,NULL,NULL) == ERROR_SUCCESS)
	{
		RegDeleteValue(key,subkeyname);
		i++;
	}
	RegCloseKey(key);
	RegDeleteKey(parentkey,keyname);
}
	

void SCHEME_DeleteEntries(void)
{
	int i;
	char keyname[64];

	for (i=0;i<num_server_types;i++)
	{
		if (!*server_types[i]->qstat_type) continue;
		sprintf(keyname,"%s-game",server_types[i]->qstat_type);
		SCHEME_DeleteTree(HKEY_CLASSES_ROOT,keyname);
	}
}

void SCHEME_Update(void)
{
	SCHEME_DeleteEntries();
	
	if (HSIG("Settings","EnableSchemes"))
		SCHEME_AddEntries();
	
	return;
}


int WINAPI SCHEME_DlgProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	int result;

	switch (msg) {
	case WM_INITDIALOG:
		SetDlgItemText(hwnd,IDT_INFO,(char*)lparam);
		SendMessage(GetDlgItem(hwnd,IDC_CONNECT),BM_SETCHECK,BST_CHECKED,0);
		return 0;

	case WM_COMMAND:
		if (wparam == IDOK) 
		{
			result = 2;
			if (IsDlgButtonChecked(hwnd,IDC_CONNECT) == BST_CHECKED)
				result = 0;
			if (IsDlgButtonChecked(hwnd,IDC_FAVOURITES) == BST_CHECKED)
				result = 1;
			EndDialog(hwnd,result);
		}
		return 0;
	case WM_CLOSE:
		EndDialog(hwnd,2);
	}
	return 0;
}

int SCHEME_DialogBox(char* type, char* addr)
{	
	char buf[512];

	sprintf(buf,"Game: %s\nAddress: %s\n\nPlease choose an option:",
		GetServerType_qstat(type)->name,addr);

	return DialogBoxParam(PROG_HINSTANCE,MAKEINTRESOURCE(IDD_SCHEMEACTION),PROG_HWND,SCHEME_DlgProc,(LPARAM)buf);
}

