/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/

/*
********
* This code is unsafe; it modifies a global variable and performs no sort of
* locking whilst doing so - this code and code in CheckIncomingData() in the
* main thread may collide
********
*/
#include <windows.h>
#include <process.h>
#include "comm.h"
#include "types.h"
//#include "hash.h"

typedef struct RECV_BUFFER 
{
	int received;
	char data[4096];
	int len;
	SOCKADDR_IN dest_addr;
	struct RECV_BUFFER* next;
} RECV_BUFFER;

static RECV_BUFFER* root;
volatile int root_safe;

int GetAccTickCount(void)
{
	LARGE_INTEGER freq, count;
	unsigned base;

	QueryPerformanceFrequency(&freq);

	if (freq.HighPart || !freq.LowPart)
		return GetTickCount();

	// freq.LowPart denotes the number of counts / second, we want per millisecond
	freq.LowPart /= 1000;

	base = 0xffffffff / freq.LowPart;
	
	QueryPerformanceCounter(&count);

	return (count.HighPart * base) + (count.LowPart / freq.LowPart);

//	result = MulDiv(count


}


int WINAPI RecvThread (void* param)
{
	RECV_BUFFER* tmp;
	int len;
	static int server_type;
	int good;
	int sck;

	/*if (param == NULL)
		return 0;
*/
	while (1)
	{
		good = 1;

		if (param)
			Sleep(1L);

		if (CheckSocket(sck = (int) HashSelect(HASH_GLOBAL,"Global","Socket",HASH_INT)) != 0)
		{
			//if (!param)
				good = 0;
			//else 
			//	good = 1;
		}			
		
		if (!good)
		{
			if (CheckSocket(sck = server_types[server_type]->bc_socket) != 0)
				good = 0;
			else good = 1;
			if (++server_type > num_server_types)
				server_type = 0;

		}

		if (!param && !good)
			return 0;

		tmp = malloc(sizeof(RECV_BUFFER));
		tmp->received = GetAccTickCount();
			
		len = sizeof(SOCKADDR_IN);
		tmp->len = recvfrom(sck, 
				tmp->data, 4096, 0, (SOCKADDR*)&tmp->dest_addr, &len);
		
		//while (!root_safe)
		//	Sleep(1L);
			
		//RecvThreadWaitSafe();

		if (tmp->len == -1)
			free(tmp);
		else
		{
			tmp->next = root;
			root = tmp;
		}
		
		//RecvThreadSetSafe(1);

		if (!param)
			return 0;
	}
	return 0;
}

int RecvThreadWaitSafe(void)
{
	while (!root_safe)
		Sleep(1);

	root_safe = 0;
	
	return root_safe;
}

int RecvThreadSetSafe(int s)
{
	root_safe = s;
	return root_safe;
}


RECV_BUFFER** RecvThreadGetRoot(void)
{
	return &root;
}

void RecvCountPackets(void)
{
	int i =0, j;
	RECV_BUFFER* tmp = root;
	while (tmp != NULL)
	{
		tmp = tmp->next;
		i++;
	}

	j = i;
}
	


void RecvThreadInit(void)
{
//		DWORD id;
//		HANDLE h;

		root = NULL;
		//root_safe = 1;
		//_beginthread(RecvThread,0,NULL);
		
//		h = CreateThread(NULL,0,RecvThread,-1,0,&id);
//		SetThreadPriority(h,THREAD_PRIORITY_HIGHEST);
}
