/*
******************************************************************
Server Query; a free games server monitoring tool
Copyright (C) 1998-2002  Nathan O'Sullivan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
******************************************************************
*/
#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"

#include "types.h"
#include "main.h"
#include "list.h"
#include "http.h"

#include "groupshared.h"

#include "funcimport.h"

//void WIREVIEW_ProcessData(char* str, int length)
//{

//Can be QuakeWorld, Quake2, Quake3, Half-Life, Unreal, UnrealT, Sof, 
// Tribes, Kingpin, Descent3, Blood2, and Quake3Demo

int WIREVIEW_StringToType(char* string)
{
	int type = 0;

	if (stricmp(string,"QuakeWorld") == 0)	type = 3;
	if (stricmp(string,"Quake2") == 0)		type = 1;
	if (stricmp(string,"Quake3") == 0)		type = 6;
	if (stricmp(string,"Half-Life") == 0)	type = 4;
	if (stricmp(string,"Unreal") == 0)		type = 7;
	if (stricmp(string,"UnrealT") == 0)		type = 10;
	if (stricmp(string,"Sof") == 0)			type = 12;
	if (stricmp(string,"Tribes") == 0)		type = 5;
	if (stricmp(string,"Kingpin") == 0)		type = 9;
	if (stricmp(string,"Descent3") == 0)	type = 0; // not supported
	if (stricmp(string,"Blood2") == 0)		type = 0; // not supported
	if (stricmp(string,"Quake3Demo") == 0)	type = 6;

	return type;
}
	
void WIREVIEW_Receive(HTTP_DATA* data) {
	
	char name[128];
	char ipaddr[128];
	server_t* svr;
	int i;

	char* str = data->data;
	char* prev;
	char svr_type[32], svr_ip[128], svr_name[128], svr_port[128], svr_data[128];
	char *ptr;
	int type_num;
	list_t *parent, *list;
	TV_ITEM item;

	parent = data->ptr;
	
	if (CURRENT_SERVER && CURRENT_LIST == parent) {
		strcpy(name,CURRENT_SERVER->name);
		strcpy(ipaddr,CURRENT_SERVER->ipaddr);
	}

	item.hItem = parent->hTreeItem;
	item.mask = TVIF_STATE;
	item.stateMask = TVIS_EXPANDED;
	TreeView_GetItem(PROG_TREEVIEW,&item);
	
	if (1 || HashSelectInt(parent,"Extra","Grouped") == 1 )
		 //|| data->windowed) 
	{
		MAIN_EmptyList(parent);
		//Sleep(500);
		//return;
	}
	else {
		for (svr = HashReset(parent,"servers",HASH_PTR);
			svr; svr = HashNext(parent,"servers",HASH_PTR) )
				HashInsertInt(svr,"items","SVR_Unused",1);
	}

	i = HashCount(parent,"servers");

	MAIN_ServersListUpdate(UPDATE_DISABLE);

	while (str<data->data+data->length) 
	{
		strcpy(svr_name,"New Server");
		strcpy(svr_ip,"");
		strcpy(svr_type,"");
		strcpy(svr_port,"");

		ptr = str;
		sscanf(ptr, "%30s", svr_type);

		while (*ptr && *ptr!= ' ' && *ptr != '\n') ptr++;
		while (*ptr && *ptr== ' ' && *ptr != '\n') ptr++;

		while (*ptr  && *ptr != '\n')
		{
			sscanf(ptr,"%120s", svr_data);

			while (*ptr && *ptr!= ' ' && *ptr != '\n') ptr++;
			while (*ptr && *ptr== ' '  && *ptr != '\n') ptr++;

			if (stricmp(svr_data,"-IPAddress") == 0)
				sscanf(ptr,"%120s",svr_ip);
			if (stricmp(svr_data,"-Port") == 0)
			{
				strcpy(svr_port,":");
				sscanf(ptr,"%120s",svr_port+1);
			}
			if (stricmp(svr_data,"-Name") == 0)
				sscanf(ptr,"%120s",svr_name);

			while (*ptr && *ptr!= ' ' && *ptr!= '\n') ptr++;
			while (*ptr && *ptr== ' ' && *ptr != '\n') ptr++;
		}

		if (svr_ip[0] != '\0') {
			strcat(svr_ip,svr_port);
			type_num = 0;

			type_num = WIREVIEW_StringToType(svr_type);

			if (type_num && MAIN_GetServerType(type_num) != MAIN_GetServerType(0))
			{
				list = parent;
				svr = NULL;
				if (HashSelectInt(list,"Extra","Grouped") == 1) 
				{
					list = MAIN_ListNamedWithParent(MAIN_GetServerType(type_num)->name,parent);
					if (!list) 
						list = MAIN_CreateList(MAIN_GetServerType(type_num)->name,"WireViewSubList",parent);
				}
				else {
					for (svr = HashReset(list,"servers",HASH_PTR) ; svr ;
						svr = HashNext(list,"servers",HASH_PTR) )
							/*WRITE_DEBUG("comparing");
							WRITE_DEBUG(svr_name);
							WRITE_DEBUG(svr->name);
							WRITE_DEBUG(svr_ip);
							WRITE_DEBUG(svr->ipaddr);*/
							if (!strcmp(svr_name,svr->name) &&
								!strcmp(svr_ip,svr->ipaddr) &&
								svr->type == type_num )
							{
								HashDelete(svr,"items","svr_unused");
								break; 
							}
				}

				if (svr == NULL) {
					WRITE_DEBUG("Adding new server");
					svr = MAIN_AddServer(list, MAIN_NewServer(svr_name,svr_ip,type_num));
					if (name[0] && !strcmp(name,svr_name) && !strcmp(svr_ip,ipaddr)) {
						/*TreeView_SelectItem(HashSelect(HASH_GLOBAL,"Global","ServersTree",HASH_PTR),
							svr->hTreeItem);*/
						SET_CURRENT_SERVER(svr);
					}
				}
			}
		}

		prev = str;
		while (str< data->data+ data->length) {
			if (memcmp("\r\n",str,2) == 0) {
				str+=2;
				break;
			}
			else if (str[0] == '\n')
			{
				str++;
				break;
			}
			else str++;
		}
	}

	for (svr = HashReset(parent,"servers",HASH_PTR); svr ; ) {
		if (HashSelectInt(svr,"items","svr_unused") == 1) {
			MAIN_DeleteServer(svr,parent);
			svr = HashReset(parent, "servers",HASH_PTR);
		}
		else svr = HashNext(parent,"servers",HASH_PTR);
	}


	if (item.state & TVIS_EXPANDED)
		TreeView_Expand(PROG_TREEVIEW,parent->hTreeItem,TVE_EXPAND);

	MAIN_ServersListUpdate(UPDATE_ENABLE);
	MAIN_ServersListUpdate(0);
	if (data->windowed)
		MAIN_ListPingAllServers(parent);
	return;
}


void WIREVIEW_UpdateListRun(list_t* list, int windowed)
{
	HTTP_DATA* data;

	data = MAIN_calloc(sizeof(HTTP_DATA),1);
	
	data->windowed = windowed;
	data->url = NULL;
	if (HashExists(list,"extra"))
		data->url = HashSelect(list,"extra","URL",HASH_STRING);
	if (!data->url)
		data->url = HashSelect(MAIN_GroupOfList(list)->location,"extra","URL",HASH_STRING);
	data->func = WIREVIEW_Receive;
	data->ptr = list;
	MAIN_HTTP_Download(data);
}

void WIREVIEW_UpdateList(list_t* list) {
	WIREVIEW_UpdateListRun(list,1);
}

void WIREVIEW_UpdateLists(void* unused)
{
	list_t* list;

	if (!HashSelect(HASH_GLOBAL,"Settings","RefreshPupServers",HASH_INT))
		return;
	
	for (list = HashReset(HASH_GLOBAL,"Lists",HASH_PTR);list;
			list = HashNext(HASH_GLOBAL,"Lists",HASH_PTR))
		if (strcmp(MAIN_GroupOfList(list)->name,"WireViewList") == 0)
			WIREVIEW_UpdateListRun(list,0);
	return;
}


// Create the 'WireView' group type
int __stdcall Init(group_shared_t* info) {

	group_t* grp = (group_t*)info->groups[0];
	group_t* def = (group_t*)info->def;

	HashInit(info->hashes,info->numHashes);

	
	FUNC_Import();
	
	// Create the 'WireView' type
	strcpy(grp->name, "WireViewList");
	strcpy(grp->desc, "WireView Server List");
	grp->refresh_list = WIREVIEW_UpdateList;
	grp->properties_list = def->properties_list;
	grp->delete_list = def->delete_list;
	MAIN_HashAlloc(grp,"Extra",4);
	HashInsert(grp,"Extra", "URL", "",HASH_STRING);
	HashInsert(grp,"Extra", "Grouped",(HASH_PARAM)0,HASH_INT);
	grp->copy_server = def->copy_server;
	grp->add_favourites = def->add_favourites;
	grp->location = grp;

	grp = (group_t*)info->groups[1];
	
	// Create the 'WireView' sub-group type
	strcpy(grp->name, "WireViewSubList");
	strcpy(grp->desc, "WireView Server List");
	grp->delete_list = def->delete_list;
	MAIN_HashAlloc(grp,"Extra",4);
	HashInsert(grp,"Extra", "Game", "",HASH_STRING);
	grp->copy_server = def->copy_server;
	grp->add_favourites = def->add_favourites;
	grp->location = grp;
	
	// Set up automated downloading of lists
	MAIN_EVENTS_Register(WIREVIEW_UpdateLists,
		NULL,
		1,60); 
		//1,1);
	
	return 2;
}
